// TestBassVis.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "TestBassVis.h"
#include "Bass.h"
#include "BassVis.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
HWND hWnd;
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

BASSVIS_PARAM lastVisParam;
BASSVIS_PARAM myVisParamVisHandle; //Cast your Handle in to BASSVIS_PARAM
BASSVIS_EXEC exec;
BASSVIS_INFO info;
HDC lastVisDC;
const int ID_TMR_REFRESH = 1;
HSTREAM hStream = 0;


// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

  memset(&lastVisParam, 0, sizeof(lastVisParam));
  memset(&exec, 0, sizeof(exec));

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TESTBASSVIS, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_TESTBASSVIS));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_TESTBASSVIS));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_TESTBASSVIS);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

void SetupBass()
{
  BOOL success = BASS_Init(-1,44100,0,0,NULL);

  BASS_SetConfig(BASS_CONFIG_FLOATDSP, TRUE);
  BASS_SetConfig(BASS_CONFIG_NET_PREBUF,0); // minimize automatic pre-buffering, so we can do it (and display it) instead
  BASS_SetConfig(BASS_CONFIG_VERIFY, 65536);
  BASS_SetConfig(BASS_CONFIG_NET_PLAYLIST, 1/* = in BASS_StreamCreateURL*/);
  BASS_SetConfig(BASS_CONFIG_GVOL_MUSIC, 10000);
  BASS_SetConfig(BASS_CONFIG_GVOL_SAMPLE, 10000);
  BASS_SetConfig(BASS_CONFIG_GVOL_STREAM, 10000);

  hStream = BASS_StreamCreateFile(FALSE, _T("Test.mp3"), 0, 0, BASS_UNICODE);
  BASS_ChannelPlay(hStream, TRUE);
}

void BASSVISDEF(BASSVIS_StateCallback)(BASSVIS_PLAYSTATE state)
{
  int i = 0;
  i = 9;
}

void SetupBassVis()
{
  // Update our vis
  if (!lastVisDC)
    lastVisDC = GetDC(hWnd);

  // TEMP: Temporarily load a plugin

  //////////////////////////////////////////////////////////////////////////
  // ----------------------------------------------------\/
  BASSVIS_KIND_T pluginKind = lastVisParam.Kind = BASSVISKIND_WMP;

  BOOL success = BASSVIS_Init(pluginKind, hInst, hWnd);
  RECT wndRect;
  GetWindowRect(hWnd, &wndRect);
  exec.Left = exec.Top = 0;
  exec.Width = wndRect.right - wndRect.left;
  exec.Height = wndRect.bottom - wndRect.top;

  switch (pluginKind)
  {
  case BASSVISKIND_WINAMP:
    {
      BASSVIS_WINAMP_SetStateCallback( BASSVIS_StateCallback );

      exec.Pluginfile = "Plugins\\vis_milk.dll";
      exec.AMP_Moduleindex = 0;
      exec.AMP_UseOwnW1 = 1;    // 
      exec.AMP_UseOwnW2 = 1;    //
      break;
    }
  case BASSVISKIND_SONIQUE:
    {
      exec.Pluginfile = "SPlugins\\CosmicBelt\\CosmicBelt.svp";
      exec.SON_ConfigFile = "SPlugins\\vis.ini";
      exec.SON_Flags = 0;
      exec.SON_PaintHandle = lastVisDC;
      break;
    }
  case BASSVISKIND_WMP:
    {
      exec.WMP_PluginIndex = 0; // TODO
      exec.WMP_PresetIndex = 0; // TODO
      exec.WMP_SrcVisHandle = hWnd;
      // Call FindPlugins once, otherwise ExecutePlugin doesn't work for WMP
      char * pluginList = BASSVIS_FindPlugins(lastVisParam.Kind, "", 0, ",");
    }
  }

  BASSVIS_ExecutePlugin(&exec, &lastVisParam);

  switch (pluginKind)
  {
  case BASSVISKIND_WINAMP:
    {
      if (lastVisParam.VisHandle != 0)
      {
        // Get HWND from Winamp Dummy Window
        HWND visWindowHandle = lastVisParam.VisWinHandle;

        // Send the last active Playlist index to visplugin
        BASSVIS_SetPlayState(&lastVisParam, psSetPlaylistPos, 0);

        // SendMessage Playing Status
        BASSVIS_SetPlayState(&lastVisParam, psPlay);

        // Check IsPlaying
        BASSVIS_SetPlayState(&lastVisParam, psIsPlaying);

        HWND hWndGen = lastVisParam.VisGenWinHandle;
        if (hWndGen != 0 && (exec.AMP_UseOwnW1 || exec.AMP_UseOwnW2))
          BASSVIS_SetVisPort(&lastVisParam, hWndGen, hWnd, 0, 0, exec.Width, exec.Height);
      }
      break;
    }
  case BASSVISKIND_WMP:
    {
      info.Channels = 2;
      //info.BitRate = 256;
      //info.SampleRate = 44100;
      info.SongTitle = "test";
      BASSVIS_SetInfo(&lastVisParam, &info);

      BASSVIS_SetModulePreset(&lastVisParam, 0); // TODO
      BASSVIS_SetPlayState(&lastVisParam, psPlay);
      BASSVIS_SetOption(&lastVisParam, BASS_WMPVIS_CONFIG_FFTAMP, 128);    // TODO

      break;
    }
  }

  if (hStream != 0)
    BASSVIS_RenderChannel(&lastVisParam, hStream);

}

//
//   FUNCTION: InitInstance(HINSTANCE, iznt)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   hInst = hInstance; // Store instance handle in our global variable
   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   SetupBass();

   SetupBassVis();

   // Set an update timer
   //SetTimer( hWnd, ID_TMR_REFRESH, 25, NULL ); // not use Timer for Visualization

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
  BASSVIS_KIND_T pluginKind = lastVisParam.Kind; //<<<< added this

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
    case WM_SIZE:

      switch ((pluginKind))
      {
      case BASSVISKIND_WINAMP:
        myVisParamVisHandle.VisHandle = (HVIS)hWnd;
        myVisParamVisHandle.Kind = BASSVISKIND_WINAMP;
        if (lastVisParam.VisHandle != 0)
          BASSVIS_Resize(&myVisParamVisHandle, 0, 0, LOWORD(lParam), HIWORD(lParam));
        break;

      case BASSVISKIND_WMP:
      case BASSVISKIND_SONIQUE:
        if (lastVisParam.VisHandle != 0)
          BASSVIS_Resize(&lastVisParam, 0, 0, LOWORD(lParam), HIWORD(lParam));  
        break;
      }

        break;
    case WM_DESTROY:

    BASSVIS_Quit(&lastVisParam);
    BASS_Free();
    KillTimer( hWnd, ID_TMR_REFRESH );

    PostQuitMessage(0);
		break;
    /*case WM_TIMER: // not use Timer for Visualization
        if (lastVisParam.VisHandle > 0)
        {
           // Get the sound data from the core
           BASSVIS_RenderChannel(&lastVisParam, hStream);
        }
        break;*/
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
