unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Bass, BassVis, ExtCtrls, StdCtrls, ComCtrls, FileCtrl, StrUtils,
  Grids, MMSystem;

const
  BASSTRUE       : DWORD = 1;
  um_MusicEnd = wm_User + 400;
  MyTimerMessage = WM_USER + 2867;

type
  TFFTData = array[0..511] of float;
  TWaveData = array[0..1023] of smallint;

  TfrmMain = class(TForm)
    btnStartVis:   TButton;
    btnConfigVis:  TButton;
    fraPlayOpt:    TGroupBox;
    btnStop:       TButton;
    btnPlay:       TButton;
    btnShow:       TButton;
    InfoTimer1:    TTimer;
    fraInputsOpt:  TGroupBox;
    Label1:        TLabel;
    Label9:        TLabel;
    LevelBar:      TTrackBar;
    ComboBox1:     TComboBox;
    fraShowOption: TGroupBox;
    optGen:        TRadioButton;
    optPanel:      TRadioButton;
    optDefault:    TRadioButton;
    lblLevel:      TLabel;
    fraListContainer: TGroupBox;
    PluginList:    TListBox;
    Descript:      TEdit;
    VisModules:    TStringGrid;
    PlayList:      TListBox;
    btnPause:      TButton;
    btnPrev:       TButton;
    btnNext:       TButton;
    Add:           TButton;
    GroupBox6:     TGroupBox;
    optDevice:     TRadioButton;
    optFile:       TRadioButton;
    Label2:        TLabel;
    Label6:        TLabel;
    lblTimeElapsed: TLabel;
    StreamOpen:    TOpenDialog;
    Label7:        TLabel;
    lblTime:       TLabel;
    ckRandom:      TCheckBox;
    lblVers:       TLabel;
    lblVersion:    TLabel;
    fraSelectVisType: TGroupBox;
    fraSonique:    TGroupBox;
    fraWinamp:     TGroupBox;
    GroupBox5:     TGroupBox;
    lblFFT:        TLabel;
    FFTSpectrumBar: TTrackBar;
    ckShowW2:      TCheckBox;
    sliSlowfade:   TTrackBar;
    sliFFTSensitivity: TTrackBar;
    sliWaveZoom:   TTrackBar;
    sliFFTZoom:    TTrackBar;
    lblFFTZoomVal: TLabel;
    lblWaveZoomVal: TLabel;
    lblFFTZoom:    TLabel;
    lblWaveZoom:   TLabel;
    Label3:        TLabel;
    cbVisType:     TComboBox;
    Label4:        TLabel;
    cbScreenRes:   TComboBox;
    lblSlowfadeVal: TLabel;
    btnStopVis: TButton;
    lblFFTSensitivityVal: TLabel;
    lblFFTSensitivity: TLabel;
    lblSlowfade: TLabel;
    fraWmp: TGroupBox;
    GroupBox2: TGroupBox;
    lblFFTWmp: TLabel;
    FFTWmpSpectrumBar: TTrackBar;
    Button1: TButton;
    PaintBox1: TPaintBox;
    ckRenderToDC: TCheckBox;
    Panel1: TPanel;
    fraBassBox: TGroupBox;
    Label5: TLabel;
    ckFPS: TCheckBox;
    ckPrgBar: TCheckBox;
    ckSlowFade: TCheckBox;
    TrackBar1: TTrackBar;
    Label8: TLabel;
    lblRenderVal: TLabel;
    procedure TrackBar1Change(Sender: TObject);
    procedure ckSlowFadeClick(Sender: TObject);
    procedure ckPrgBarClick(Sender: TObject);
    procedure ckFPSClick(Sender: TObject);
    procedure ckRenderToDCClick(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure btnConfigVisMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VisModulesClick(Sender: TObject);
    procedure FFTWmpSpectrumBarChange(Sender: TObject);
    procedure cbScreenResChange(Sender: TObject);
    procedure Panel1DblClick(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sliFFTSensitivityChange(Sender: TObject);
    procedure sliWaveZoomChange(Sender: TObject);
    procedure sliFFTZoomChange(Sender: TObject);
    procedure btnStopVisClick(Sender: TObject);
    procedure sliSlowfadeChange(Sender: TObject);
    procedure cbVisTypeChange(Sender: TObject);
    procedure InfoTimer1Timer(Sender: TObject);
    procedure optFileClick(Sender: TObject);
    procedure optDeviceClick(Sender: TObject);
    procedure btnPrevClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnPauseClick(Sender: TObject);
    procedure PlayListDblClick(Sender: TObject);
    procedure AddClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnShowClick(Sender: TObject);
    procedure PluginListClick(Sender: TObject);
    procedure optGenClick(Sender: TObject);
    procedure optDefaultClick(Sender: TObject);
    procedure optPanelClick(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnStartVisClick(Sender: TObject);
    //procedure btnStopVisClick(Sender: TObject);
    procedure FFTSpectrumBarChange(Sender: TObject);
    procedure LevelBarChange(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnPlayClick(Sender: TObject);
  private
    { Private declarations }
    MediaTitle    : string;
    StreamFile    : string;
    PlaylistCount : integer;
    PlaylistPos   : integer;
    EndSync       : HSync;
    StreamLength  : Float;
    Paused        : boolean;
    hWndGen       : DWORD;
    PluginDir     : string;
    IndexNum      : integer;
    ISPlaying     : DWORD;
    plist         : TStringList;
    pathList      : TStringList;
    hWndWinAMP    : DWORD;
    FullScreen    : boolean;
    FScreenWidth  : Integer;
    FScreenHeight : Integer;
  protected
    procedure RenderProc(var Msg: TMessage); message MyTimerMessage;
    procedure MusicEnd(var Msg: TMessage); message um_MusicEnd;
    function GetSongPosStr(timeinms: Double): string;
    procedure GetPluginInfo(Index: integer);
    procedure GetPlugin(Index: integer);

  public
    { Public declarations }
    function GetFFTdata: TFFTData;
    function GetWaveData: TWaveData;
  end;


var
  frmMain          : TfrmMain;
  lHwndParent      : HWND;
  Stream           : DWORD;
  StreamPos        : DWORD;
  PlaylistTitlePos : integer;
  RecChan          : HRECORD;
  dc               : DWORD;
  m_lId            : DWORD;
  OldProc          : Pointer;
  
  //BassVis Parameter
  mMediaInfo    : TBASSVIS_INFO;
  mExec         : TBASSVIS_EXEC;
  mVisParam     : TBASSVIS_PARAM;

implementation

uses frmGen,
  IniFiles;

{$R *.dfm}

function TfrmMain.GetFFTdata: TFFTData;
begin
    BASS_ChannelGetData(Stream, @Result, BASS_DATA_FFT1024);
end;


function TfrmMain.GetWaveData: TWaveData;
begin
  Bass_ChannelGetData(Stream, @result, 1024);
end;


// Callback for handle play/pause/stop buttons
// and navigate List in an plugin
procedure MyCallBack(NewState: TPlaystate); stdcall;
var
  PlaylistFile  : string;
  MediaTitle    : string;
  Title         : string;
  copyDataStruct: PCopyDataStruct;

begin


  case NewState of
    //  Plugin send stop
    psStop:
    begin
      if (BASS_ChannelIsActive(Stream) = BASS_ACTIVE_PLAYING) or
        (BASS_ChannelIsActive(Stream) = BASS_ACTIVE_PAUSED) then

        frmMain.btnStopClick(nil);
      BASSVIS_SetPlayState(@mVisParam, psStop);
    end;
    // Plugin send play
    psPlay:
    begin
      if not (BASS_ChannelIsActive(Stream) = BASS_ACTIVE_PLAYING) and
        not (BASS_ChannelIsActive(Stream) = BASS_ACTIVE_PAUSED) then
        frmMain.btnPlayClick(nil)
      else
      begin
        BASS_ChannelPlay(Stream, False);
        BASSVIS_SetPlayState(@mVisParam, psPlay);
        frmMain.Paused := False;
      end;
    end;
    // Plugin send pause
    psPause:
    begin
      frmMain.Paused := False;
      frmMain.btnPauseClick(nil);
      BASSVIS_SetPlayState(@mVisParam, psPause);
    end;
    // Plugin send play preview Title
    psPrevTitle:
    begin
      frmMain.PlaylistPos := frmMain.Playlist.ItemIndex;
      if frmMain.PlaylistPos > 0 then
        frmMain.btnPrevClick(nil);
    end;
    // Plugin send play next Title
    psNextTitle:
    begin
      if frmMain.PlaylistPos < (frmMain.Playlist.Count - 1) then
        frmMain.btnNextClick(nil);
    end;
    // set aktive Playlist entry from Plugin to your PlayList
    psSetPlaylistPos:
    begin
      frmMain.Playlist.ItemIndex := BASSVIS_SetPlayState(@mVisParam, psGetSelectedTitlePos);
      frmMain.PlaylistPos := frmMain.Playlist.ItemIndex;
      frmMain.btnPlayClick(nil)
    end;
    // Plugin send give me a Playlist Title
    psSetPlaylistTitle:
    begin
      if (frmMain.Playlist.Count <> 0) and (frmMain.Plist.Count <> 0) then
      begin
        PlaylistFile  := frmMain.Plist.Strings[PlaylistTitlePos];

        MediaTitle  := ExtractFileName(AnsiLeftStr(PlaylistFile, Length(PlaylistFile) - 4));
        BASSVIS_SetPlayState(@mVisParam, psSetPlaylistTitle, -1, PAnsiChar(MediaTitle));

      end;
    end;
    // Plugin send index from Plugin List
    psGetPlaylistTitlePos:
      PlaylistTitlePos := BASSVIS_SetPlayState(@mVisParam, psGetPlaylistTitlePos);

    // Plugin clear Playlist
    psPlaylistClear:
    begin
      frmMain.playlist.Clear;
      frmMain.Plist.Clear;
    end;
    // Plugin send new Playlist entry
    psAddPlaylistTitle:
    begin
       copyDataStruct := Pointer(BASSVIS_SetPlayState(@mVisParam, psAddPlaylistTitle));
       Title := PAnsiChar(copyDataStruct.lpData);
       frmMain.Plist.Add(Title);
       frmMain.playlist.Items.add(ExtractFileName(AnsiLeftStr(Title, Length(Title) - 4)));
    end;
  end;

end;


procedure SyncProc(Handle: HSync; Channel, Data: DWORD; User: DWORD); stdcall;
begin
    PostMessage(frmMain.Handle, um_MusicEnd, 0, 0);

end;


procedure TfrmMain.RenderProc(var Msg: TMessage);
Var
  FFTData  : TFFTData;
  WaveData : TWaveData;

begin
    Case mVisParam.Kind of
      BASSVISKIND_SONIQUE:
        if frmMain.optFile.checked then
        begin

          if stream <> 0 then
          begin

            FFTData := frmMain.GetFFTdata;
            WaveData := frmMain.GetWaveData;

            // get stream position from bass
            StreamPos := Round(1000 * Bass_ChannelBytes2Seconds(Stream,
                         Bass_ChannelGetPosition(Stream, BASS_POS_BYTE)));


            If not (frmMain.optGen.checked = True) Then
              dc := frmmain.PaintBox1.Canvas.Handle
            else
              dc := GetDc(frm_Gen.PBack.handle);
          
            BASSVIS_SONIQUEVIS_RenderToDC2(mVisParam.Kind,
                                           mVisparam.VisHandle,
                                           @WaveData,
                                           @FFTData,
                                           dc,
                                           BASS_SAMPLE_MONO, StreamPos)
            end else
            begin
              dc := GetDc(frmMain.Panel1.Handle);
              BASSVIS_SONIQUEVIS_RenderToDC2(mVisParam.Kind,
                                             mVisparam.VisHandle,
                                             @WaveData,
                                             @FFTData,
                                             dc,
                                             BASS_SAMPLE_MONO, StreamPos)
        end;
        end else
        begin
          If not (frmMain.optGen.checked = True) Then
            dc := frmmain.PaintBox1.Canvas.Handle
          else
            dc := GetDc(frm_Gen.PBack.handle);

          BASSVIS_SONIQUEVIS_RenderToDC(mVisParam.Kind,
                                        mVisparam.VisHandle,
                                        RecChan,
                                        dc);
        end;
    end;

end;


procedure TimerProc(wTimerID: DWORD; Msg : DWORD; dwUser: longint;
                                                   dw1 : longint;
                                                   dw2 : longint); stdcall;
begin
    PostMessage(frmMain.Handle, MyTimerMessage, dw1, dw2);
end;


// recording callback
function RecordCallback(handle: HRECORD; buffer: Pointer; length: DWORD; user: DWORD): BOOL; stdcall;
begin
  Result := boolean(BASSTRUE);
end;


procedure TfrmMain.FormCreate(Sender: TObject);
var
  i     : integer;
  ini   : TIniFile;
  fn    : string;
  DeviceName : PAnsiChar;
  Volumelevel : Single;

begin

  self.Width := 480;

  // check the correct BASS was loaded
  if (HIWORD(BASS_GetVersion) <> BASSVERSION) then
  begin
    MessageBox(0, 'An incorrect version of BASS.DLL was loaded', nil, MB_ICONERROR);
    Halt;
  end;

	if (not BASS_RecordInit(-1)) or (not BASS_Init(-1, 44100, 0, Handle, nil)) then
	begin
		BASS_RecordFree;
		BASS_Free();
		MessageDlg('Cannot start default recording device!', mtError, [mbOk], 0);
		Halt;
	end;

	i := 0;
	DeviceName := BASS_RecordGetInputName(i);
	while DeviceName <> nil do
	begin
		ComboBox1.Items.Add(StrPas(DeviceName));
		// is this one currently "on"?
		if (BASS_RecordGetInput(i, Volumelevel) and BASS_INPUT_OFF) = 0 then
        	ComboBox1.ItemIndex := i;
		Inc(i);
		DeviceName := BASS_RecordGetInputName(i);
	end;
    ComboBox1.ItemIndex := 0;	// display info

  BASS_RecordGetInput(ComboBox1.ItemIndex, Volumelevel);
  LevelBar.Position := Round(Volumelevel * 100);

  // create IniFile
  fn  := ChangeFileExt(application.exename, '.ini');
  ini := TIniFile.Create(fn);

  //Load Default Plugin Kind
  mVisParam.Kind := ini.ReadInteger('PluginType', 'Kind', 1);

  cbScreenRes.ItemIndex := ini.ReadInteger('PluginType', 'ScreenResolution', 0);
  cbScreenResChange(nil);
   
  //Get Version of BassVis
  lblVersion.Caption := BASSVIS_GetVersion;

  //find avaiable Plugins
  if mVisParam.Kind < 0 then
    mVisParam.Kind := 0;

  cbVisType.ItemIndex := mVisParam.Kind;
  cbVisTypeChange(nil);

  ini.Free;
end;


procedure TfrmMain.FormDestroy(Sender: TObject);
begin

  plist.Free;
  StreamOpen.Free;
  InfoTimer1.Enabled := False;

  // NEVER forget ...
  //remove BassVis from memory and free all resources
  BASSVIS_QUIT(@mVisParam);
  Bass_Free;

end;



procedure TfrmMain.ComboBox1Click(Sender: TObject);
var
  Volumelevel: single;
begin

  BASS_RecordGetInput(ComboBox1.ItemIndex, Volumelevel);
  LevelBar.Position := Round(Volumelevel * 100);
end;


procedure TfrmMain.GetPluginInfo(Index: integer);
var
  Pluginname: string;
  NumModule: integer;
  IntI: integer;
  NumPresets: Integer;
  PlgDescription: string;

begin

  mVisParam.Kind := Index;
  IndexNum := PluginList.ItemIndex;

  case mVisParam.Kind of
    BASSVISKIND_WINAMP:
    begin
      mVisparam.VisHandle := cardinal(BASSVIS_GetPluginHandle(mVisParam.Kind,
                                      PAnsiChar(PluginDir +
                                      PluginList.Items[IndexNum])));

      NumModule  := BASSVIS_GetModulePresetCount(@mVisParam,
                                                 PAnsiChar(PluginDir +
                                                 PluginList.Items[IndexNum]));

      Pluginname := BASSVIS_GetPluginName(@mVisParam);

      if NumModule = 0 then
        Exit;

      Descript.Text := Pluginname;

      VisModules.RowCount := NumModule;
      for IntI := 0 to NumModule - 1 do
        VisModules.Cells[0, IntI] := BASSVIS_GetModulePresetName(@mVisParam,
                                                                 IntI,
                                                                 PAnsiChar(PluginDir +
                                                                 PluginList.Items[IndexNum]));

      if NumModule > 0 then
        VisModules.Row := 0;

      if (Stream <> 0) and (NumModule = 1) then
        btnStartVisClick(nil);
    end;

    BASSVISKIND_SONIQUE:
    begin
      Descript.Text := 'Avaiable Module';

      mExec.Pluginfile := PAnsiChar(pathlist.Strings[IndexNum]);
      mExec.SON_ConfigFile        := PAnsiChar(PluginDir + '\vis.ini');
      mExec.SON_Flags             := BASS_VIS_NOINIT;

      if mVisparam.VisHandle <> 0 then
        BASSVIS_Free(@mVisParam);

      BASSVIS_ExecutePlugin(@mExec, mVisParam);

      VisModules.Cells[0, 0] := BASSVIS_GetPluginName(@mVisParam);
      VisModules.Row := 0;

      if (Stream <> 0) or (optDevice.Checked = True) then
        btnStartVisClick(nil);


    end;

    BASSVISKIND_WMP:
    begin
        NumPresets := BASSVIS_GetModulePresetCount(@mVisParam, PAnsiChar(PluginList.Items[IndexNum]));
        PlgDescription := BASSVIS_GetPluginName(@mVisParam);

        If NumPresets = 0 Then
            Exit;

        Descript.Text := PlgDescription;

        VisModules.RowCount := NumPresets;
        for IntI := 0 to NumPresets - 1 do
          VisModules.Cells[0, IntI] := BASSVIS_GetModulePresetName(@mVisParam,
                                                                 IntI,
                                                                 PAnsiChar(PluginList.Items[IndexNum]));

      if NumPresets > 0 then
        VisModules.Row := 0;

      if (Stream <> 0) or (optDevice.Checked = True) then
        btnStartVisClick(nil);
    end;

    BASSVISKIND_BASSBOX:
    begin

      mExec.Pluginfile := PAnsiChar(pathlist.Strings[IndexNum]);
      mExec.BB_Flags              := BASS_VIS_NOINIT;

      BASSVIS_ExecutePlugin(@mExec, mVisParam);

      PlgDescription := BASSVIS_GetPluginName(@mVisParam);
      Descript.Text := PlgDescription;

      VisModules.Cells[0, 0] := BASSVIS_GetModulePresetName(@mVisParam,
                                                            0,
                                                            PAnsiChar(PluginList.Items[IndexNum]));
      VisModules.Row := 0;

      if (Stream <> 0) or (optDevice.Checked = True) then
        btnStartVisClick(nil);

    end;
  end;

end;


procedure TfrmMain.GetPlugin(Index: integer);
var
  IntI:  integer;
  flist: string;
  alist: TSplitStrArray;

begin

  // clear plugin list
  PluginList.Clear;

  case index of
    BASSVISKIND_WINAMP:
    begin
      // find out vis plugins
      flist := BASSVIS_FindPlugins(mVisParam.Kind, PAnsiChar(PluginDir),
        BASS_VIS_FIND_RECURSIVE);

      alist := Split(flist, ',');

      if (flist > '') then
      begin

        for IntI := 0 to High(alist) do
          PluginList.Items.Add(ExtractFileName(PAnsiChar(alist[IntI])));


        if PluginList.Count > 0 then
        begin
          PluginList.ItemIndex := 0;

          // Get Plugin Information
          GetPluginInfo(Index);
        end else
        begin
          Descript.Text := '';
          VisModules.RowCount := 0;
        end;
      end;

    end;

    BASSVISKIND_SONIQUE:
    begin
      pathList := TStringList.Create;
      pathList.Clear;

      // find out vis plugins
      flist := BASSVIS_FindPlugins(mVisParam.Kind, PAnsiChar(PluginDir),
                                   BASS_VIS_FIND_RECURSIVE);

      alist := Split(flist, ',');

      if flist > '' then
        for IntI := 0 to High(alist) do
        begin
          PluginList.Items.Add(ExtractFileName(PAnsiChar(alist[IntI])));
          pathList.Add(alist[IntI]);
        end;


      if PluginList.Count > 0 then
      begin
        PluginList.ItemIndex := 0;

        // Get Plugin Information
        GetPluginInfo(Index);
      end else
      begin
        Descript.Text := '';
        VisModules.RowCount := 0;
      end;
    end;
    
    BASSVISKIND_WMP:
    begin
      // find out vis plugins
      // '{0AA02E8D-F851-4CB0-9F64-BBA9BE7A983D}'
      flist := BASSVIS_FindPlugins(mVisParam.Kind, '', 0);

      alist := Split(flist, ',');

      if flist > '' then
        for IntI := 0 to High(alist) do
          PluginList.Items.Add(PAnsiChar(alist[IntI]));

      if PluginList.Count > 0 then
      begin
        PluginList.ItemIndex := 0;

        // Get Plugin Information
        GetPluginInfo(Index);
      end else
      begin
        Descript.Text := '';
        VisModules.RowCount := 0;
      end;

    end;

    BASSVISKIND_BASSBOX:
    begin
      pathList := TStringList.Create;
      pathList.Clear;

      // find out vis plugins
      flist := BASSVIS_FindPlugins(mVisParam.Kind, PAnsiChar(PluginDir),
                                   BASS_VIS_FIND_RECURSIVE);

      alist := Split(flist, ',');

      if flist > '' then
        for IntI := 0 to High(alist) do
        begin
          PluginList.Items.Add(ExtractFileName(PAnsiChar(alist[IntI])));
          pathList.Add(alist[IntI]);
        end;


      if PluginList.Count > 0 then
      begin
        PluginList.ItemIndex := 0;

        // Get Plugin Information
        GetPluginInfo(Index);
      end else
      begin
        Descript.Text := '';
        VisModules.RowCount := 0;
      end;
    end;

  end;
end;


procedure TfrmMain.btnShowClick(Sender: TObject);
begin
  if self.Width = 480 then
  begin
    btnShow.Caption := '<<';
    self.Width      := 822;
  end
  else
  begin
    self.Width      := 480;
    btnShow.Caption := '>>';
  end;

end;


procedure TfrmMain.btnStartVisClick(Sender: TObject);

var
  Bufferlength: integer;
  Buffer:  array [0..MAX_PATH] of AnsiChar;
  IsFree:  boolean;
  Counter: integer;
  strBuffer: string;
  ini: TIniFile;
  _HDC : HDC;

begin

  // check if we have something selected on the list
  if (PluginList.ItemIndex >= 0) and (PluginList.ItemIndex < PluginList.Count) then

  begin

    if m_lId <> 0 Then
    begin
      //Timer stoppen
      timeKillEvent(m_lId);
      m_lId := 0;
    end;

    if (mVisParam.VisHandle <> 0) then
    begin
      InfoTimer1.Enabled := False;
      //Remove CallBack
      if mVisParam.Kind = BASSVISKIND_WINAMP then
        BASSVIS_WINAMP_RemoveCallback;

      if frm_Gen.Visible = True then
      begin
        frm_Gen.Hide;
        frm_Gen.Close;
        frm_Gen.FormDestroy(Sender);
      end;

      Counter := 0;
      BASSVIS_Free(@mVisParam);
      repeat
        IsFree := BASSVIS_IsFree(@mVisParam);
        Inc(Counter);
      until (IsFree = True) or (Counter = 250);
      mVisParam.Vishandle := 0;
    end;
  end;

  case mVisParam.Kind of
    BASSVISKIND_WINAMP:
    begin
      // create our new plugin
      if (optPanel.Checked) or (optGen.Checked) = True then
      begin
        mExec.Pluginfile := PAnsiChar(PluginDir + PluginList.Items[IndexNum]);
        mExec.AMP_Moduleindex       := VisModules.Selection.Top;
        mExec.AMP_UseOwnW1          := 1;
        mExec.AMP_UseOwnW2          := Ord(ckShowW2.Checked);

        BASSVIS_ExecutePlugin(@mExec, mVisParam);

      end else
      if optDefault.Checked = True then
      begin
        mExec.Pluginfile := PAnsiChar(PluginDir + PluginList.Items[IndexNum]);
        mExec.AMP_Moduleindex       := VisModules.Selection.Top;
        mExec.AMP_UseOwnW1          := 0;
        mExec.AMP_UseOwnW2          := 0;

        BASSVIS_ExecutePlugin(@mExec, mVisParam);
      end;

      if mVisParam.Vishandle <> 0 then
      begin
        // Get HWND from Winamp Dummy Window
        hWndWinAMP := mVisParam.VisWinhandle;

        // send the last active Playlist index to visplugin
        BASSVIS_SetPlayState(@mVisParam, psSetPlaylistPos, PlaylistPos);

        // SendMessage Playing Status
        BASSVIS_SetPlayState(@mVisParam, psPlay);

        // Check IsPlaying
        BASSVIS_SetPlayState(@mVisParam, psIsPlaying);

        if optPanel.Checked = True then
        begin
          hWndGen := mVisParam.VisGenWinhandle;

        if hWndGen <> 0 then
          BASSVIS_SetVisPort(@mVisParam,
            hWndGen,
            Panel1.Handle,
            0,
            0,
            Panel1.Width,
            Panel1.Height);
        end else
          // reset Container Handle
          // if handle more then 0 Plugin go back to Panel
          // when resize default Window
          BASSVIS_SetVisPort(@mVisParam,
                             hWndGen,
                             0,
                             0,
                             0,
                             0,
                             0);

        if optGen.Checked = True then
        begin
          hWndGen := mVisParam.VisGenWinhandle;

          if hWndGen <> 0 then
          begin
            //read Caption from Plugin
            Bufferlength := GetWindowTextLength(hWndGen);
            GetWindowText(hWndGen, Buffer, Bufferlength + 1);
            // load skin/setting/position
            frm_Gen.FormShow(Sender);
            //set String
            frm_Gen.picTopText.Width :=
              frm_Gen.GetBitArray(LeftStr(Buffer,
              Bufferlength)) + 15;
            //Form Gen resizen
            frm_Gen.FormResize(Sender);

            //Set Width/Height on 'frm_Gen.PBack'
            BASSVIS_SetVisPort(@mVisParam,
                               hWndGen,
                               frm_Gen.PBack.handle,
                               0,
                               0,
                               frm_Gen.PBack.Width,
                               frm_Gen.PBack.Height);

            frm_Gen.Show;
          end;
        end;
        BASSVIS_WINAMP_SetStateCallback(MyCallBack);

        if optDevice.Checked = True then
        begin
          BASS_RecordInit(0);
          BASSVIS_StartRecord(@mVisParam);
        end;

        if (Stream <> 0) and (optfile.Checked = True) then
          BASSVIS_RenderChannel(@mVisParam, Stream);

        FFTSpectrumbar.position := 16;
        InfoTimer1.Enabled := True;

      end;
    end;

    BASSVISKIND_SONIQUE:
    begin
      If optPanel.checked = True Then
      begin
        // Only  set SON_PaintHandle > 0 do not use RenderProc
        if not (ckRenderToDC.Checked = true) then
          _HDC := GetDc(Panel1.handle)
        else
        _HDC := 0;

        mExec.Pluginfile := PAnsiChar(pathlist.Strings[IndexNum]);
        mExec.SON_ConfigFile        := PAnsiChar(PluginDir + '\vis.ini');
        mExec.SON_Flags             := 0;
        mExec.SON_PaintHandle       := _HDC;
        mExec.Left                  := 0;
        mExec.Top                   := 0;
        if not (ckRenderToDC.Checked = true) then
        begin
        mExec.Width              := Panel1.Width;
        mExec.Height             := Panel1.Height;
        end else
        begin
          mExec.Width              := PaintBox1.Width;
          mExec.Height             := PaintBox1.Height;
        end;

        BASSVIS_ExecutePlugin(@mExec, mVisParam);
        ini := TIniFile.Create(ChangeFileExt(application.exename, '.ini'));
        sliSlowfade.Position := ini.ReadInteger('PluginType', 'Slowfade',  2);
        ini.Free;
      end;

      If optGen.checked = True Then
      begin
        // Only  set SON_PaintHandle > 0 do not use RenderProc
        if not (ckRenderToDC.Checked = true) then
          _HDC := GetDc(frm_Gen.PBack.handle)
        else
        _HDC := 0;

        // only retrive the handle
        mExec.Pluginfile := PAnsiChar(pathlist.Strings[IndexNum]);
        mExec.SON_ConfigFile        := PAnsiChar(PluginDir + '\vis.ini');
        mExec.SON_Flags             := BASS_VIS_NOINIT;

        BASSVIS_ExecutePlugin(@mExec, mVisParam);

        hWndGen := mVisParam.VisHandle;

        If hWndGen <> 0 Then
        begin
          // clear DC
          PaintBox1.Refresh;

          //read Caption from Plugin
          strBuffer := BASSVIS_GetPluginName(@mVisParam);
          Bufferlength := Length(strBuffer);
          // load skin/setting/position
          frm_Gen.FormShow(Sender);
          //set String
          frm_Gen.picTopText.Width := frm_Gen.GetBitArray(LeftStr(strBuffer,
                                                          Bufferlength)) + 15;
          //Form Gen resizen
          frm_Gen.FormResize(Sender);

          // Plugin auf die weite/hhe von 'frmGen.PicBack' anpassen
          mExec.Pluginfile := PAnsiChar(pathlist.Strings[IndexNum]);
          mExec.SON_ConfigFile        := PAnsiChar(PluginDir + '\vis.ini');
          mExec.SON_Flags             := 0;
          mExec.SON_PaintHandle       := _HDC;
          mExec.Left                  := 0;
          mExec.Top                   := 0;
          mExec.Width                 := frm_Gen.PBack.Width;
          mExec.Height                := frm_Gen.PBack.Height;

          BASSVIS_ExecutePlugin(@mExec, mVisParam);

          //Set Width/Height on 'frm_Gen.PBack'
          BASSVIS_SetVisPort(@mVisParam,
              hWndGen,
              GetDc(frm_Gen.PBack.handle),
              0,
              0,
              frm_Gen.PBack.Width,
              frm_Gen.PBack.Height);

          frm_Gen.Show;

          ini := TIniFile.Create(ChangeFileExt(application.exename, '.ini'));
          sliSlowfade.Position := ini.ReadInteger('PluginType', 'Slowfade',  2);
          ini.Free;
          Panel1.Refresh;
        end;
    end;

    If mVisParam.Vishandle <> 0 Then
      if ckRenderToDC.Checked = false then
      begin
        Panel1.Visible := true;
        If optDevice.checked = True Then
        begin
          BASS_RecordInit(0);
          BASSVIS_StartRecord(@mVisParam);
        end;

        If (Stream <> 0) And (optfile.checked = True) Then
          BASSVIS_RenderChannel(@mVisParam, Stream);

      end else
      begin
        // RenderToDC
        Panel1.Visible := False;
        If optDevice.checked = True Then
        begin

          BASS_RecordInit(0);
          RecChan := BASS_RecordStart(44100, 2, 0, @RecordCallback, nil);
          if (RecChan = 0) then
          begin
            MessageBox(0, 'Cant start recording', 'Error', 0);
            Halt;
          end;

          If (m_lId = 0) then
            m_lId := timeSetEvent(25, 300, @TimerProc, Application.Handle, TIME_PERIODIC);

        end else
        If (Stream <> 0) And (optfile.checked = True) Then
        begin
          if  RecChan <> 0 then
            BASS_RecordFree;

          If (m_lId = 0) then
            m_lId := timeSetEvent(25, 300, @TimerProc, Application.Handle, TIME_PERIODIC);

        end;
      end;
      sliFFTSensitivity.Position := 0;
      Trackbar1.Position := 25;
      InfoTimer1.Enabled := True;
    end;

    BASSVISKIND_WMP:
    begin
      Panel1.Visible := true;
      if (optPanel.Checked) or (optDefault.Checked) = True then
      begin
        mMediaInfo.channels := 2;
        mMediaInfo.SampleRate := 44100;
        mMediaInfo.SongTitle := PAnsiChar(MediaTitle);

        BASSVIS_SetInfo(@mVisParam, @mMediaInfo);

        mExec.WMP_PluginIndex := PluginList.ItemIndex;
        mExec.WMP_PresetIndex := 0;
        mExec.WMP_SrcVisHandle := Panel1.Handle;
        mExec.Left := 0;
        mExec.top := 0;
        mExec.Width := Panel1.Width;
        mExec.Height := Panel1.Height;

        BASSVIS_ExecutePlugin(@mExec, mVisParam);
      end;

      If optGen.checked = True Then
      begin
        mExec.WMP_PluginIndex := PluginList.ItemIndex;
        mExec.WMP_PresetIndex := 0;
        mExec.WMP_SrcVisHandle := frm_Gen.PBack.handle;
        mExec.Left := 0;
        mExec.top := 0;
        mExec.Width := frm_Gen.PBack.Width;
        mExec.Height := frm_Gen.PBack.Height;

        BASSVIS_ExecutePlugin(@mExec, mVisParam);
        hWndGen := mVisParam.VisHandle;

        If hWndGen <> 0 Then
        begin
          //read Caption from Plugin
          strBuffer := PAnsiChar(Descript.Text);
          Bufferlength := Length(strBuffer);
          // load skin/setting/position
          frm_Gen.FormShow(Sender);
          //set String
          frm_Gen.picTopText.Width :=
          frm_Gen.GetBitArray(LeftStr(strBuffer, Bufferlength)) + 15;
          //Form Gen resizen
          frm_Gen.FormResize(Sender);

          //Set Width/Height on 'frm_Gen.PBack'
          BASSVIS_SetVisPort(@mVisParam,
              hWndGen,
              frm_Gen.PBack.handle,
              0,
              0,
              frm_Gen.PBack.Width,
              frm_Gen.PBack.Height);

          frm_Gen.Show;
          Panel1.Refresh;
        end;
      end;

      // SendMessage Playing Status
      BASSVIS_SetPlayState(@mVisParam, psPlay);

      if optDevice.Checked = True then
      begin
        BASS_RecordInit(0);
        BASSVIS_StartRecord(@mVisParam);
      end;

      if (Stream <> 0) and (optfile.Checked = True) then
        BASSVIS_RenderChannel(@mVisParam, Stream);

      FFTWmpSpectrumbar.position := 128;
      InfoTimer1.Enabled := True;
    end;

    BASSVISKIND_BASSBOX:
    begin
      If optPanel.checked = True Then
      begin

        mExec.Pluginfile := PAnsiChar(pathlist.Strings[IndexNum]);
        mExec.BB_Flags              := 0;
        mExec.BB_ParentHandle       := Panel1.Handle;
        mExec.BB_ShowFPS            := ckFPS.Checked;
        mExec.BB_ShowPrgBar         := ckPrgBar.Checked;
        mExec.Left                  := 0;
        mExec.Top                   := 0;
        mExec.Width                 := Panel1.Width;
        mExec.Height                := Panel1.Height;

        BASSVIS_ExecutePlugin(@mExec, mVisParam);
      end else

      If optGen.checked = True Then
      begin

        // only retrive the handle
        mExec.Pluginfile := PAnsiChar(pathlist.Strings[IndexNum]);
        mExec.BB_Flags              := BASS_VIS_NOINIT;

        BASSVIS_ExecutePlugin(@mExec, mVisParam);

        hWndGen := mVisParam.VisHandle;

        If hWndGen <> 0 Then
        begin

          //read Caption from Plugin
          strBuffer := BASSVIS_GetModulePresetName(@mVisParam,
                                                   0,
                                                   PAnsiChar(PluginList.Items[IndexNum]));
          Bufferlength := Length(strBuffer);
          // load skin/setting/position
          frm_Gen.FormShow(Sender);
          //set String
          frm_Gen.picTopText.Width := frm_Gen.GetBitArray(LeftStr(strBuffer,
                                                          Bufferlength)) + 15;
          //Form Gen resizen
          frm_Gen.FormResize(Sender);

          // Plugin auf die weite/hhe von 'frmGen.PicBack' anpassen
          mExec.Pluginfile := PAnsiChar(pathlist.Strings[IndexNum]);
          mExec.BB_Flags              := 0;
          mExec.BB_ParentHandle       := frm_Gen.PBack.handle;
          mExec.BB_ShowFPS            := ckFPS.Checked;
          mExec.BB_ShowPrgBar         := ckPrgBar.Checked;
          mExec.Left                  := 0;
          mExec.Top                   := 0;
          mExec.Width                 := frm_Gen.PBack.Width;
          mExec.Height                := frm_Gen.PBack.Height;

          BASSVIS_ExecutePlugin(@mExec, mVisParam);

          //Set Width/Height on 'frm_Gen.PBack'
          BASSVIS_SetVisPort(@mVisParam,
              hWndGen,
              frm_Gen.PBack.handle,
              0,
              0,
              frm_Gen.PBack.Width,
              frm_Gen.PBack.Height);

          frm_Gen.Show;
          Panel1.Refresh;
        end;
      end;

    If mVisParam.Vishandle <> 0 Then
      begin
        Panel1.Visible := True;
        If optDevice.checked = True Then
        begin
          BASS_RecordInit(0);
          BASSVIS_StartRecord(@mVisParam);
        end;

        If (Stream <> 0) And (optfile.checked = True) Then
          BASSVIS_RenderChannel(@mVisparam, Stream);

      end;
      InfoTimer1.Enabled := True;
    end;
  end;

end;


procedure TfrmMain.btnStopVisClick(Sender: TObject);
begin

  if m_lId <> 0 Then
  begin
     //Timer stoppen
     timeKillEvent(m_lId);
     m_lId := 0;
  end;

  if Panel1.visible then
    Panel1.Refresh
  else
    PaintBox1.Refresh;

  // Timer disabled
  // do not send any to BassVis when playing a file
  // and change visplugin
  if stream <> 0 then
    InfoTimer1.Enabled := False;

  if frm_Gen.Visible = True then
  begin
    frm_Gen.Hide;
    frm_Gen.Close;
    frm_Gen.FormDestroy(Sender);
  end;

  BASSVIS_Free(@mVisParam);


end;


procedure TfrmMain.Button1Click(Sender: TObject);
begin

  if playlist.Count <> 0 then
  begin
    playlist.Clear;
    plist.Clear;
    plist.Free;

    plist := nil;
  end;

end;

procedure TfrmMain.cbScreenResChange(Sender: TObject);
var
  ini: TIniFile;

begin
    Case cbScreenRes.ItemIndex of

    0:
      begin
        FScreenWidth := 320;
        FScreenHeight := 240;
      end;
    1:
      begin
        FScreenWidth := 512;
        FScreenHeight := 384;
      end;
    2:
      begin
        FScreenWidth := 640;
        FScreenHeight := 480;
      end;
    3:
      begin
        FScreenWidth := 800;
        FScreenHeight := 600;
      end;
    4:
      begin
        FScreenWidth := 1024;
        FScreenHeight := 768;
      end;
    5:
      begin
        FScreenWidth := 1280;
        FScreenHeight := 1024;
      end;

    end;

    ini := TIniFile.Create(ChangeFileExt(application.exename, '.ini'));
    ini.WriteInteger('PluginType', 'ScreenResolution',  cbScreenRes.ItemIndex);
    ini.Free;
end;

procedure TfrmMain.cbVisTypeChange(Sender: TObject);
var
  ini: TIniFile;

begin
  //deactivate Timer
  InfoTimer1.Enabled := False;

  if Panel1.visible then
    Panel1.Refresh
  else
    PaintBox1.Refresh;

  //Remove CallBack
  BASSVIS_WINAMP_RemoveCallback;

  // clear module list
  VisModules.RowCount := 0;
  VisModules.Cells[0, 0] := '';

  // clear Plugin info
  Descript.Text := '';

  if (mVisParam.Vishandle <> 0) then
  begin
    BASSVIS_Quit(@mVisParam);
    Panel1.Refresh;
  end;

  mVisParam.Kind := cbVisType.ItemIndex + 1;

  case mVisParam.Kind of
    BASSVISKIND_WINAMP:
    begin
      //initialize BassVis
      BASSVIS_Init(BASSVISKIND_WINAMP, Application.Handle, frmMain.Handle);
      PluginDir := ExtractFilePath(Application.ExeName) + 'Plugins\';
      fraWinamp.BringToFront;
      //SetCallBack for PlayState
      BASSVIS_WINAMP_SetStateCallback(MyCallBack);
    end;
    BASSVISKIND_SONIQUE:
    begin
      //initialize BassVis
      BASSVIS_Init(BASSVISKIND_SONIQUE, Application.Handle, frmMain.Handle);
      PluginDir := ExtractFilePath(Application.ExeName) + 'SPlugins';
      fraSonique.BringToFront;
    end;
    BASSVISKIND_WMP:
    begin
      BASSVIS_Init(BASSVISKIND_WMP, Application.Handle, frmMain.Handle);
      fraWmp.BringToFront;
    end;
    BASSVISKIND_BASSBOX:
    begin
      BASSVIS_Init(BASSVISKIND_BASSBOX, Application.Handle, frmMain.Handle);
      PluginDir := ExtractFilePath(Application.ExeName) + 'BBPlugin';
      fraBassBox.BringToFront;
    end;
  end;

  GetPlugin(mVisParam.Kind);
  ini := TIniFile.Create(ChangeFileExt(application.exename, '.ini'));
  ini.WriteInteger('PluginType', 'Kind', cbVisType.ItemIndex);
  ini.Free;

end;


procedure TfrmMain.ckFPSClick(Sender: TObject);
begin
  // required new start
  btnStartVisClick(Sender);

end;

procedure TfrmMain.ckPrgBarClick(Sender: TObject);
begin
  // start new Plugin
  btnStartVisClick(Sender);

end;

procedure TfrmMain.ckRenderToDCClick(Sender: TObject);
begin
  // start new Plugin
  btnStartVisClick(Sender);

end;

procedure TfrmMain.ckSlowFadeClick(Sender: TObject);
begin
  If mVisParam.Kind = BASSVISKIND_SONIQUE Then
    BASSVIS_SetOption(@mVisParam, BASS_SONIQUEVIS_CONFIG_USESLOWFADE, DWord(ckSlowFade.checked));

end;

procedure TfrmMain.FFTSpectrumBarChange(Sender: TObject);
begin
  If mVisParam.Kind = BASSVISKIND_WINAMP Then
  begin
  BASSVIS_SetOption(@mVisParam, BASS_VIS_CONFIG_FFTAMP,
    FFTSpectrumBar.Position);
  lblFFT.Caption := IntToStr(FFTSpectrumBar.Position * 32);
  end;
end;


procedure TfrmMain.FFTWmpSpectrumBarChange(Sender: TObject);
begin
  If mVisParam.Kind = BASSVISKIND_WMP Then
  begin
    BASSVIS_SetOption(@mVisParam, BASS_VIS_CONFIG_FFTAMP,
      FFTWmpSpectrumBar.Position);
    lblFFTWmp.Caption := IntToStr(FFTWmpSpectrumBar.Position * 32);
  end;
end;


procedure TfrmMain.LevelBarChange(Sender: TObject);
begin

  BASS_RecordSetInput(ComboBox1.ItemIndex, BASS_INPUT_ON, LevelBar.Position / 100);
  lblLevel.Caption := IntToStr(LevelBar.Position);
end;


procedure TfrmMain.AddClick(Sender: TObject);
var
  IntI: integer;

begin
  if not assigned(plist) then
    plist := TStringList.Create;

  PlaylistTitlePos := 0;

  if StreamOpen.Execute then
  begin

    for IntI := 0 to StreamOpen.Files.Count - 1 do
    begin
      //get file
      StreamFile := StreamOpen.Files[IntI];
      playlist.Items.add(ExtractFileName(AnsiLeftStr(StreamFile, Length(StreamFile) - 4)));
      plist.Add(StreamFile);
    end;
  end;

  if playlist.Count <> 0 then
  begin
    playlist.Selected[playlist.TopIndex] := True;

    btnPlay.Enabled  := True;
    btnStop.Enabled  := True;
    btnPrev.Enabled  := True;
    btnPause.Enabled := True;
    btnNext.Enabled  := True;

    PlaylistCount := playlist.Count;
    PlaylistPos   := playlist.ItemIndex;
  end else
  begin
    // Stop stream when available
    if Stream <> 0 then
      Bass_ChannelStop(Stream);

    // SendMessage Status Stop
    BASSVIS_SetPlayState(@mVisParam, psStop);

    // Terminate Plugin
    btnStopVisClick(Sender);
  end;

end;


procedure TfrmMain.btnConfigVisMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var
  NewSelection: TGridRect;

begin
  case mVisParam.Kind of
    BASSVISKIND_WINAMP:
    begin
      if PluginList.Items.Count > 0 then
      begin
        IndexNum := PluginList.ItemIndex;

        mVisparam.VisHandle := cardinal(BASSVIS_GetPluginHandle(mVisparam.Kind,
                                        PAnsiChar(
                                        PluginDir + PluginList.Items
                                        [IndexNum])));
        if mVisparam.VisHandle <> 0 then
          BASSVIS_Config(@mVisparam, VisModules.Selection.Top);

      end else
      exit;

      NewSelection := VisModules.Selection;
      if NewSelection.Top > (IndexNum - 1) then
        exit;
      end;
      BASSVISKIND_WMP, BASSVISKIND_BASSBOX:
      begin
        BASSVIS_Config(@mVisParam, VisModules.Selection.Top);
      end;
  end;
end;


procedure TfrmMain.btnNextClick(Sender: TObject);
begin

  if Playlist.ItemIndex = (Playlist.Count - 1) then
    Playlist.ItemIndex := 0
  else
    Playlist.ItemIndex := Playlist.ItemIndex + 1;

  Playlist.Selected[Playlist.ItemIndex] := True;
  btnPlayClick(Sender);

end;


procedure TfrmMain.btnStopClick(Sender: TObject);
begin

  // Stop stream when available
  if Stream <> 0 then
    Bass_ChannelStop(Stream);

  // SendMessage Status Stop
  BASSVIS_SetPlayState(@mVisParam, psStop);

  // Check Stop Status
  ISPlaying := BASSVIS_SetPlayState(@mVisParam, psIsPlaying);
  if ISPlaying = 0 then
    MediaTitle := ' Nix mehr';

end;


procedure TfrmMain.btnPauseClick(Sender: TObject);
begin

  Paused := not Paused;
  if Paused = False then
  begin
    if Stream <> 0 then
      Bass_ChannelPlay(Stream, False);

    // SendStatus Play
    BASSVIS_SetPlayState(@mVisParam, psPlay);

  end else
  begin
    if Stream <> 0 then
      Bass_ChannelPause(Stream);

    // SendStatus Paused
    BASSVIS_SetPlayState(@mVisParam, psPause);

  end;

end;


procedure TfrmMain.btnPlayClick(Sender: TObject);

begin

  if Stream <> 0 then
  begin
    BASS_ChannelStop(Stream);
    Stream := 0;
  end;

  PlaylistPos := playlist.ItemIndex;
  StreamFile  := plist.Strings[playlist.ItemIndex];
  MediaTitle  := ExtractFileName(AnsiLeftStr(StreamFile, Length(StreamFile) - 4));

  stream := Bass_StreamCreateFile(False, PAnsiChar(StreamFile), 0, 0, 0);

  if Stream <> 0 then
  begin
    EndSync := Bass_ChannelSetSync(Stream, Bass_SYNC_END, 0, @SyncProc, nil);
    lblTime.Caption := GetSongPosStr(1000 * Bass_ChannelBytes2Seconds
                                    (Stream, Bass_ChannelGetLength(Stream, 0)));
    // play the filestream
    Bass_ChannelPlay(Stream, True);
    BASSVIS_SetPlayState(@mVisParam, psPlay);

  end;

  case mVisParam.Kind of
    BASSVISKIND_WINAMP:
      if hWndWinAMP <> 0 then
      begin
        // send the last active Playlist index to visplugin
        BASSVIS_SetPlayState(@mVisParam, psSetPlaylistPos, PlaylistPos);

        // Send Status Play
        BASSVIS_SetPlayState(@mVisParam, psPlay);
        IsPlaying := BASSVIS_SetPlayState(@mVisParam, psIsPlaying);

        // Check Play Status
        if IsPlaying = 1 then
          InfoTimer1.Enabled := True
        else
          InfoTimer1.Enabled := False;

        if (mVisParam.Vishandle <> 0) and (optDevice.Checked = False) then
          BASSVIS_RenderChannel(@mVisParam, Stream);

      end else
        InfoTimer1.Enabled := True;

    BASSVISKIND_SONIQUE:
    begin
      if (mVisParam.Vishandle <> 0) and (optDevice.Checked = False) then
        if not (ckRenderToDC.Checked = true)  then
          BASSVIS_RenderChannel(@mVisParam, Stream);

        ISPlaying := BASSVIS_SetPlayState(@mVisParam, psIsPlaying);
        InfoTimer1.Enabled := True;
    end;

    BASSVISKIND_WMP:
    begin
      mMediaInfo.channels := 2;
      mMediaInfo.BitRate := 44100;
      mMediaInfo.SongTitle := PAnsiChar(MediaTitle);

      BASSVIS_SetInfo(@mVisParam, @mMediaInfo);

      if (mVisParam.Vishandle <> 0) and (optDevice.Checked = False) then
        BASSVIS_RenderChannel(@mVisParam, Stream);

      ISPlaying := BASSVIS_SetPlayState(@mVisParam, psIsPlaying);
      InfoTimer1.Enabled := True;
    end;

    BASSVISKIND_BASSBOX:
    begin
      mMediaInfo.channels := 2;
      mMediaInfo.BitRate := 44100;

      BASSVIS_SetInfo(@mVisParam, @mMediaInfo);

      if (mVisParam.Vishandle <> 0) and (optDevice.Checked = False) then
        if not (ckRenderToDC.Checked = true)  then
          BASSVIS_RenderChannel(@mVisParam, Stream);

      ISPlaying := BASSVIS_SetPlayState(@mVisParam, psIsPlaying);
      InfoTimer1.Enabled := True;
    end;

  end;

end;


procedure TfrmMain.btnPrevClick(Sender: TObject);
begin

  if Playlist.ItemIndex = 0 then
    Playlist.ItemIndex := Playlist.Count - 1
  else
    Playlist.ItemIndex := Playlist.ItemIndex - 1;

  Playlist.Selected[Playlist.ItemIndex] := True;
  btnPlayClick(Sender);

end;


procedure TfrmMain.InfoTimer1Timer(Sender: TObject);

begin

  if Stream <> 0 then
  begin
    // format position HH:MM:SS write in to lblTime
    lblTimeElapsed.Caption :=
      GetSongPosStr(1000 * Bass_ChannelBytes2Seconds(Stream,
      Bass_ChannelGetPosition(Stream, BASS_POS_BYTE)));

    // get stream position from bass
    StreamPos := round(1000 * Bass_ChannelBytes2Seconds(Stream,
      Bass_ChannelGetPosition(Stream, BASS_POS_BYTE)));

    // get stream length from bass
    StreamLength := Bass_ChannelBytes2Seconds(Stream,
      Bass_ChannelGetLength(Stream, BASS_POS_BYTE));
  end;

  //Set MediaInfo
  case mVisParam.Kind of
    BASSVISKIND_WINAMP:

      if (MediaTitle <> '') and (hWndWinAMP <> 0) then
      begin
        // set listindex and point for MediaTitle
        // any plugins not work when not use this with Title
        mMediaInfo.SongTitle   := PAnsiChar(IntToStr(PlaylistPos + 1) + '. ' + MediaTitle);
        mMediaInfo.Songfile    := PAnsiChar(StreamFile);
        mMediaInfo.pos         := round(StreamPos);
        mMediaInfo.len         := round(StreamLength);
        mMediaInfo.PlaylistPos := PlaylistPos;
        mMediaInfo.Playlistlen := PlaylistCount;

        BASSVIS_SetInfo(@mVisParam, @mMediaInfo);
      end;
    BASSVISKIND_SONIQUE:
      if (MediaTitle <> '') and (mVisParam.VisHandle <> 0) then
      begin
        mMediaInfo.SongTitle   := PAnsiChar(MediaTitle);
        mMediaInfo.pos         := round(StreamPos);
        mMediaInfo.len         := round(StreamLength);

        BASSVIS_SetInfo(@mVisParam, @mMediaInfo);
      end;
    BASSVISKIND_WMP:
    begin
      mMediaInfo.channels := 2;
      mMediaInfo.SampleRate := 44100;
      mMediaInfo.SongTitle := PAnsiChar(MediaTitle);

      BASSVIS_SetInfo(@mVisParam, @mMediaInfo);
    end;
    BASSVISKIND_BASSBOX:
    begin
      mMediaInfo.SongTitle := PAnsiChar(MediaTitle);
      mMediaInfo.pos         := round(StreamPos);
      mMediaInfo.len         := round(StreamLength);

      BASSVIS_SetInfo(@mVisParam, @mMediaInfo);
    end;
  end;

end;


procedure TfrmMain.optDefaultClick(Sender: TObject);
begin

  // start new Plugin
  btnStartVisClick(Sender);

end;


procedure TfrmMain.optDeviceClick(Sender: TObject);
begin

  // start new Plugin
  btnStartVisClick(Sender);

end;


procedure TfrmMain.optFileClick(Sender: TObject);
begin

  // start new Plugin
  btnStartVisClick(Sender);

end;


procedure TfrmMain.optGenClick(Sender: TObject);
begin

  // start new Plugin
  btnStartVisClick(Sender);

end;


procedure TfrmMain.optPanelClick(Sender: TObject);
begin

  // start new Plugin
  btnStartVisClick(Sender);

end;


procedure TfrmMain.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    Case mVisParam.Kind of

    BASSVISKIND_SONIQUE:
      BASSVIS_SONIQUEVIS_Clicked(mVisParam.Vishandle, x, y );
    end;
    
end;



procedure TfrmMain.Panel1DblClick(Sender: TObject);
var
  Rect : TRect;

begin

    FullScreen := Not FullScreen;
    Case mVisParam.Kind of

    BASSVISKIND_SONIQUE:
        BASSVIS_SetFullscreen(@mVisParam,
                              Panel1.Handle,
                              frmMain.Handle,
                              490,
                              8,
                              320,
                              240,
                              FullScreen,
                              FScreenWidth,
                              FScreenHeight);
    BASSVISKIND_WMP:
        BASSVIS_SetFullscreen(@mVisParam,
                              Panel1.Handle,
                              frmMain.Handle,
                              490,
                              8,
                              320,
                              240,
                              FullScreen,
                              FScreenWidth,
                              FScreenHeight);

    BASSVISKIND_BASSBOX:
         begin
           // Do not use BASSVIS_SetFullscreen critical on Vista
           if FullScreen then
           begin
             GetWindowRect(GetDesktopWindow, Rect);
             BASSVIS_SetVisPort(@mVisParam,
                                Panel1.Handle,
                                GetDesktopWindow,
                                0,
                                0,
                                Rect.Right,
                                Rect.Bottom);
             SetWindowPos(Panel1.Handle, HWND_TOPMOST, 0, 0, 0, 0,
                          SWP_NOACTIVATE Or SWP_NOSIZE Or SWP_NOMOVE)

           end else
           begin
             BASSVIS_SetVisPort(@mVisParam,
                                Panel1.Handle,
                                Handle,
                                490,
                                8,
                                320,
                                240);

             SetWindowPos(Panel1.Handle, HWND_NOTOPMOST, 0, 0, 0, 0,
                          SWP_NOACTIVATE Or SWP_NOSIZE Or SWP_NOMOVE)
           end;

         end;




    end;
    self.Width := 822;
    self.Height := 616;

end;

procedure TfrmMain.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    Case mVisParam.Kind of

    BASSVISKIND_SONIQUE:
      BASSVIS_SONIQUEVIS_Clicked(mVisParam.Vishandle, x, y );
    end;
end;


procedure TfrmMain.PlayListDblClick(Sender: TObject);
begin

  InfoTimer1.Enabled := False;

  // play filestream
  btnPlayClick(Sender);

end;


procedure TfrmMain.PluginListClick(Sender: TObject);
begin

  GetPluginInfo(cbVisType.ItemIndex + 1);
end;


function TfrmMain.GetSongPosStr(timeinms: double): string;
var
  time_s: double;
  hours, minutes, seconds, dsec: integer;
begin

  if timeinms >= 0 then
  begin
    { New improved time calculating code }
    time_s  := timeinms * 0.001;
    hours   := Trunc(time_s / 60 / 60) mod 60;
    time_s  := time_s - (hours * 60 * 60);
    minutes := Trunc(time_s / 60);
    time_s  := time_s - (minutes * 60);
    seconds := Trunc(time_s);
    time_s  := time_s - seconds;
    dsec    := Trunc(time_s * 100);

    if hours > 0 then
      Result := Format('%2d:%.2d:%.2d.%.2d', [hours, minutes, seconds, dsec])
    else
      Result := Format('%.2d:%.2d.%.2d', [minutes, seconds, dsec]);
  end else
    Result := '';
end;


procedure TfrmMain.sliFFTSensitivityChange(Sender: TObject);
begin
  If mVisParam.Kind = BASSVISKIND_SONIQUE Then
  begin
    BASSVIS_SetOption(@mVisParam, BASS_VIS_CONFIG_FFTAMP, (sliFFTSensitivity.Position));
    lblFFTSensitivityVal.Caption := IntToStr(sliFFTSensitivity.Position);
  end;

end;

procedure TfrmMain.sliFFTZoomChange(Sender: TObject);
begin
  If mVisParam.Kind = BASSVISKIND_SONIQUE Then
  begin
    BASSVIS_SetOption(@mVisParam, BASS_SONIQUEVIS_CONFIG_FFT_SKIPCOUNT, (sliFFTZoom.Position));
    lblFFTZoomVal.Caption := IntToStr(sliFFTZoom.Position);
 end;

end;


procedure TfrmMain.sliSlowfadeChange(Sender: TObject);
  var
  ini: TIniFile;

begin
  If mVisParam.Kind = BASSVISKIND_SONIQUE Then
  begin
    BASSVIS_SetOption(@mVisParam, BASS_SONIQUEVIS_CONFIG_SLOWFADE, (sliSlowfade.position));
    lblSlowfadeVal.Caption := IntToStr(sliSlowfade.Position);
  end;

  ini := TIniFile.Create(ChangeFileExt(application.exename, '.ini'));
  ini.WriteInteger('PluginType', 'Slowfade',  sliSlowfade.Position);
  ini.Free;

end;


procedure TfrmMain.sliWaveZoomChange(Sender: TObject);
begin
  If mVisParam.Kind = BASSVISKIND_SONIQUE Then
  begin
    BASSVIS_SetOption(@mVisParam, BASS_SONIQUEVIS_CONFIG_WAVE_SKIPCOUNT, (sliWaveZoom.Position));
    lblWaveZoomVal.Caption := IntToStr(sliWaveZoom.Position);
  end;

end;


procedure TfrmMain.TrackBar1Change(Sender: TObject);
begin
  If mVisParam.Kind = BASSVISKIND_SONIQUE Then
  begin
    BASSVIS_SetOption(@mVisParam, BASS_SONIQUEVIS_CONFIG_RENDERTIMING, (TrackBar1.position));
    lblRenderVal.Caption := IntToStr(TrackBar1.Position);
  end;
end;

procedure TfrmMain.VisModulesClick(Sender: TObject);
begin
  If mVisParam.Kind = BASSVISKIND_WMP Then
  begin
    If (Stream <> 0) Or (optDevice.checked = True) Then
      BASSVIS_SetModulePreset(@mVisParam, VisModules.Selection.Top);
  end;

end;


procedure TfrmMain.MusicEnd(var Msg: TMessage);
begin

  if ckRandom.Checked then
  begin
    if (playlist.ItemIndex = playlist.Count - 1) then
    begin
      playlist.ItemIndex := 0;
      playlist.Selected[playlist.ItemIndex] := True;

      // play filestream
      btnPlayClick(nil);
      exit;
    end else
      playlist.ItemIndex := playlist.ItemIndex + 1;
    playlist.Selected[playlist.ItemIndex] := True;

    // play filestream
    btnPlayClick(nil);
  end else
    // stop filestream
    btnStopClick(nil);
end;

end.
