
Option Explicit On

Imports System.IO
Imports Bass = Un4seen.Bass.Bass
Imports GWLIndex = Un4seen.Bass.AddOn.Vis.GWLIndex
Imports BASSWINAMPVISConfig = Un4seen.Bass.AddOn.Vis.BASSVISConfig
Imports BASSWINAMPFindPlugin = Un4seen.Bass.AddOn.Vis.BASSVISPFindPlugin
Imports Vis = Un4seen.Bass.AddOn.Vis
Imports BASSVIS = Un4seen.Bass.AddOn.Vis.BassVis
Imports BASSStream = Un4seen.Bass.BASSStreamsystem
Imports Marshal = System.Runtime.InteropServices.Marshal
Imports BassNet = Un4seen.Bass.BassNet
Imports BASSSync = Un4seen.Bass.BASSSync
Imports BASSInput = Un4seen.Bass.BASSInput
Imports BassActive = Un4seen.Bass.BASSActive
Imports BassMode = Un4seen.Bass.BASSMode

Public Class frmMain

    Private flist() As String
    Private PluginDir As String
    Private MediaTitle As String
    Private StreamFile As String
    Private PlaylistCount As Integer
    Private Stream As Integer
    Private SyncEnd As Integer
    Private StreamPos As Single
    Private StreamLength As Single
    Private Paused As Boolean
    Private inputdevice As Integer
    Private StartRecord As Boolean
    Private RenderStream As Boolean
    Private PlaylistTitlePos As Integer


    Public Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" ( _
        ByVal hwnd As Int32 _
    ) As Int32

    Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" ( _
        ByVal hwnd As Int32, _
        ByVal lpString As String, _
        ByVal cch As Int32 _
    ) As Int32

    Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Int32) As Int32

    Private IndexNum As Int32
    Private VisWindowHandle As Int32 = 0
    Private GenVisible As Boolean
    Private FullScreen As Boolean = False
    Private FScreenWidth As Int32
    Private FScreenHeight As Int32

    Private mVisParam As Un4seen.Bass.AddOn.Vis.BASS_VIS_PARAM
    Private mExec As Un4seen.Bass.AddOn.Vis.BASS_VIS_EXEC
    Private mInfos As Un4seen.Bass.AddOn.Vis.BASS_VIS_INFO
    Private mVisCallback As Un4seen.Bass.AddOn.Vis.BASSVISSTATE
    
    ' ************** End BASSVIS Interface **************
    '*****************************************************

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        tmrChanInfo.Enabled = False
        BASSVIS.BASS_VIS_Quit(mVisParam)
        Bass.BASS_RecordFree()
        Bass.BASS_Free()
        End

    End Sub

    Public Sub SyncEndProc(ByVal handle As Integer, ByVal channel As Integer, ByVal data As Integer, ByVal user As IntPtr)

        ' go back from Un4seen.Bass.SYNCPROC to original Thread
        ' do not set SyncEndProc outside from frmMain this will not work
        ' new call of frmMain (outside from frmMain) begin a new Thread of frmMain and destroy the original Handle
        Me.Invoke(New System.Windows.Forms.MethodInvoker(AddressOf Me.MusikEnd))

    End Sub

    Private Sub GetPluginInfo(ByVal index As Int32)

        Dim Pluginname As String
        Dim NumModule As Integer
        Dim IntI As Integer
        Dim NumPresets As Integer

        mVisParam.Kind = index

        ' clear module list
        VisModules.Items.Clear()

        ' clear Plugin info
        Descript.Text = Nothing

        Select Case index
            Case Vis.BASSVISPlugin.BASSVISKIND_WINAMP
                mVisParam.VisHandle = BASSVIS.BASS_VIS_GetPluginHandle(cbVisType.SelectedIndex, PluginDir & "\" & lstPlugins.Items(IndexNum))
                NumModule = BASSVIS.BASS_VIS_GetModulePresetCount(mVisParam, PluginDir & "\" & lstPlugins.Items(IndexNum))
                Pluginname = BASSVIS.BASS_VIS_GetPluginName(mVisParam)

                If Not (NumModule > 0) Then
                    Exit Sub
                End If
                Descript.Text = Pluginname

                With VisModules
                    For IntI = 0 To (NumModule - 1)
                        .Items.Add(BASSVIS.BASS_VIS_GetModulePresetName(mVisParam, IntI, PluginDir & "\" & lstPlugins.Items(IndexNum)))
                    Next
                End With

                If NumModule > 0 Then
                    VisModules.SelectedIndex = 0
                End If

                If Stream <> 0 And NumModule = 1 Then
                    cmdStartVis_Click(Nothing, Nothing)
                End If

            Case Vis.BASSVISPlugin.BASSVISKIND_SONIQUE

                Descript.Text = "Avaiable Module"
                ' create a new instanze of mExec
                If mExec Is Nothing Then
                    mExec = New Vis.BASS_VIS_EXEC(Vis.BASSVISPlugin.BASSVISKIND_SONIQUE)
                End If

                With mExec
                    .PluginFile = lstPlgPath.Items(IndexNum) + lstPlugins.Items(IndexNum)
                    .SON_ConfigFile = PluginDir & "\" & "vis.ini"
                    .SON_Flags = Vis.BASSVISFlags.BASS_VIS_NOINIT
                End With

                BASSVIS.BASS_VIS_ExecutePlugin(mExec, mVisParam)
                Pluginname = BASSVIS.BASS_VIS_GetPluginName(mVisParam)

                If Pluginname <> "" Then
                    With VisModules
                        .Items.Add(Pluginname)
                    End With

                    VisModules.SelectedIndex = 0

                    If Stream <> 0 Or (optDevice.Checked = True) Then
                        cmdStartVis_Click(Nothing, Nothing)
                    End If
                End If

            Case Vis.BASSVISPlugin.BASSVISKIND_WMP

                NumPresets = BASSVIS.BASS_VIS_GetModulePresetCount(mVisParam, lstPlugins.Items(IndexNum))
                Descript.Text = BASSVIS.BASS_VIS_GetPluginName(mVisParam)

                If NumPresets = 0 Then
                    Exit Sub
                End If

                With VisModules
                    For IntI = 0 To NumPresets - 1
                        .Items.Add(BASSVIS.BASS_VIS_GetModulePresetName(mVisParam, IntI, lstPlugins.Items(IndexNum)))
                    Next
                End With

                VisModules.SelectedIndex = 0

                If Stream <> 0 Or (optDevice.Checked = True) Then
                    cmdStartVis_Click(Nothing, Nothing)
                End If

        End Select
        SaveSetting(Application.ProductName, "BassVis", "Kind", CStr(index))

    End Sub


    Private Sub GetPlugin(ByVal index As Int32)

        Dim IntI As Integer
        Dim flist() As String

        ' clear plugin list
        lstPlugins.Items.Clear()

        ' clear module list
        VisModules.Items.Clear()

        ' clear Plugin info
        Descript.Text = vbNullString

        Select Case index
            Case Vis.BASSVISPlugin.BASSVISKIND_WINAMP

                flist = BASSVIS.BASS_VIS_FindPlugins( _
                                cbVisType.SelectedIndex, _
                                PluginDir, _
                                Vis.BASSVISPFindPlugin.BASS_VIS_FIND_RECURSIVE)

                If Not flist Is Nothing And Not flist(0) = "" Then
                    For IntI = flist.GetLowerBound(0) To flist.GetUpperBound(0)

                        lstPlugins.Items.Add(GetFileName(flist(IntI)))
                        lstPlgPath.Items.Add(GetPath(flist(IntI)))

                    Next IntI
                End If

                If lstPlugins.Items.Count > 0 Then
                    lstPlugins.SelectedIndex = 0
                    IndexNum = 0

                    ' Get Plugin Information
                    GetPluginInfo(index)
                Else
                    Descript.Text = vbNullString
                End If

            Case Vis.BASSVISPlugin.BASSVISKIND_SONIQUE

                ' find out vis plugins
                flist = BASSVIS.BASS_VIS_FindPlugins( _
                                cbVisType.SelectedIndex, _
                                PluginDir, _
                                Vis.BASSVISPFindPlugin.BASS_VIS_FIND_RECURSIVE)

                If Not flist Is Nothing And Not flist(0) = "" Then
                    For IntI = flist.GetLowerBound(0) To flist.GetUpperBound(0)

                        lstPlugins.Items.Add(GetFileName(flist(IntI)))
                        lstPlgPath.Items.Add(GetPath(flist(IntI)))

                    Next IntI
                End If

                If lstPlugins.Items.Count > 0 Then
                    lstPlugins.SelectedIndex = 0
                    IndexNum = 0

                    ' Get Plugin Information
                    GetPluginInfo(index)
                Else
                    Descript.Text = vbNullString
                End If

            Case Vis.BASSVISPlugin.BASSVISKIND_WMP
                ' find out vis plugins
                flist = BASSVIS.BASS_VIS_FindPlugins(cbVisType.SelectedIndex, "", 0)

                If Not flist Is Nothing And Not flist(0) = "" Then
                    For IntI = flist.GetLowerBound(0) To flist.GetUpperBound(0)
                        lstPlugins.Items.Add(flist(IntI))

                    Next IntI
                End If

                If lstPlugins.Items.Count > 0 Then
                    lstPlugins.SelectedIndex = 0
                    IndexNum = 0

                    ' Get Plugin Information
                    GetPluginInfo(index)
                Else
                    Descript.Text = vbNullString
                End If

        End Select

    End Sub

    Private Sub tmrChanInfo_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmrChanInfo.Tick

        On Error Resume Next

        If Stream <> 0 Then
            ' format position HH:MM:SS write in to lblTime
            lblElapsed.Text = GetTime(Bass.BASS_ChannelBytes2Seconds(Stream, Bass.BASS_ChannelGetPosition(Stream, BassMode.BASS_POS_BYTES)))

            ' get stream position from bass
            StreamPos = Bass.BASS_ChannelBytes2Seconds(Stream, Bass.BASS_ChannelGetPosition(Stream, BassMode.BASS_POS_BYTES))

            ' get stream length from bass
            StreamLength = Bass.BASS_ChannelBytes2Seconds(Stream, Bass.BASS_ChannelGetLength(Stream, BassMode.BASS_POS_BYTES))
        End If

        'Set MediaInfo
        Select Case mVisParam.Kind

            Case Vis.BASSVISPlugin.BASSVISKIND_WINAMP
                If (MediaTitle <> "") And (mVisParam.VisHandle <> 0) Then

                    ' set listindex and point for MediaTitle
                    ' any plugins not work when not use this with Title
                    ' create a new instanze of mInfos
                    If mInfos Is Nothing Then
                        mInfos = New Vis.BASS_VIS_INFO(MediaTitle, StreamFile)
                    End If

                    With mInfos
                        .SongTitle = (PlaylistPos + 1) & ". " & MediaTitle
                        .SongFile = StreamFile
                        .Position = 1000 * StreamPos
                        .Length = StreamLength
                        .PlaylistPos = PlaylistPos
                        .PlaylistLen = Playlist.Items.Count
                    End With

                    BASSVIS.BASS_VIS_SetInfo(mVisParam, mInfos)

                End If

            Case Vis.BASSVISPlugin.BASSVISKIND_WINAMP
                With mInfos
                    .Channels = 2
                    .SampleRate = 44100
                    .SongTitle = MediaTitle
                End With

                BASSVIS.BASS_VIS_SetInfo(mVisParam, mInfos)

        End Select

        On Error GoTo 0
    End Sub


    Private Sub BassInit()

        Dim BassPath As String
        Dim BassVisPath As String
        Dim InputName As Integer

        BassPath = "%Path%;" & Application.StartupPath & "\BassLib"
        SetEnvironmentVariable("Path", BassPath)


        ' check the correct BASS was loaded
        If (HiWord(Bass.BASS_GetVersion) <> Bass.BASSVERSION) Then
            MsgBox("Falsche version der BASS.DLL wurde geladen", vbCritical)
            End
        End If

        'Set Path to AddOns
        BassVisPath = "%Path%;" & Application.StartupPath & "\BassADDOn"
        SetEnvironmentVariable("Path", BassVisPath)

        'Check "bass_Vis.dll" exist
        If Not FileExists(RPP(Application.StartupPath) & "\BassADDOn\bass_Vis.dll") Then
            MsgBox("BASS_Vis.DLL existiert nicht!", vbCritical, "BASS_Vis.DLL")
            End
        End If

        ' setup recording and output devices (using default devices)
        If (Bass.BASS_RecordInit(-1) = False) Or (Bass.BASS_Init(-1, 44100, 0, Me.Handle, Nothing) = False) Then
            MsgBox("Can't initialize device", vbCritical, "BASS.DLL")
            End
        Else
            ' get list of inputs
            input_ = -1
            Do While Bass.BASS_RecordGetInputName(InputName) <> ""
                cmbInputs.Items.Add(Bass.BASS_RecordGetInputName(InputName))
                If (Bass.BASS_RecordGetInput(InputName, 0) And BASSInput.BASS_INPUT_OFF) = 0 Then
                    cmbInputs.SelectedIndex = InputName
                    input_ = InputName
                End If
                InputName += 1
            Loop
        End If

        Me.Text = "BassVis VB.NET 2008 Sample:  BassVis Version: " & BASSVIS.BASS_VIS_GetVersion

        Me.Width = 489

    End Sub

    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim Index As Int32

        BassInit()


        Index = GetSetting(Application.ProductName, "BassVis", "Kind", CInt("1"))
        ' create a new instanze of mVisParam
        If mVisParam Is Nothing Then
            mVisParam = New Vis.BASS_VIS_PARAM(Index)
        End If

        cbVisType.SelectedIndex = mVisParam.Kind

    End Sub

    Private Sub lstPlugins_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstPlugins.Click

        If Not IndexNum = lstPlugins.SelectedIndex Then
            IndexNum = lstPlugins.SelectedIndex
            GetPluginInfo(mVisParam.Kind)
        End If


    End Sub

    Private Sub cmdResize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdResize.Click

        If Me.Width = 489 Then
            Me.Width = 840
            cmdResize.Text = "<<"
        Else
            Me.Width = 489
            cmdResize.Text = ">>"
        End If

    End Sub


    Private Sub cmbConfig_Click(ByVal send As System.Object, ByVal e As System.EventArgs) Handles cmdConfig.Click

        If lstPlugins.Items.Count > 0 Then
            Select Case mVisParam.Kind

                Case Vis.BASSVISPlugin.BASSVISKIND_WINAMP

                    IndexNum = lstPlugins.SelectedIndex
                    mVisParam.VisHandle = BASSVIS.BASS_VIS_GetPluginHandle(cbVisType.SelectedIndex, PluginDir & "\" & lstPlugins.Items(IndexNum))

                    If mVisParam.VisHandle <> 0 Then
                        BASSVIS.BASS_VIS_Config(mVisParam, VisModules.SelectedIndex)
                    Else
                        Exit Sub
                    End If
                Case Vis.BASSVISPlugin.BASSVISKIND_WMP
                    BASSVIS.BASS_VIS_Config(mVisParam, VisModules.SelectedIndex)
            End Select

        End If

    End Sub

    Private Sub cmdPrev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPrev.Click

        PlayPrev()

    End Sub

    Private Sub PlayPrev()

        If Playlist.SelectedIndex = 0 Then
            Playlist.SelectedIndex = Playlist.Items.Count - 1
        Else
            Playlist.SelectedIndex = Playlist.SelectedIndex - 1
        End If
        PlaylistPos = Playlist.SelectedIndex

        BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.SetPlaylistPos, Playlist.SelectedIndex)

        PlayFile()

    End Sub


    Private Sub PlayNext()

        If Playlist.SelectedIndex = (Playlist.Items.Count - 1) Then
            Playlist.SelectedIndex = 0
        Else
            Playlist.SelectedIndex = Playlist.SelectedIndex + 1
        End If
        BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.SetPlaylistPos, Playlist.SelectedIndex)
        PlaylistPos = Playlist.SelectedIndex

        PlayFile()

    End Sub

    Private Sub cmdNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdNext.Click

        PlayNext()

    End Sub

    Private Sub cmdPlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPlay.Click

        PlayFile()

    End Sub

    Private Sub PlayFile()

        Dim nReturn As Int32 = 0

        If Stream <> 0 Then
            Bass.BASS_ChannelStop(Stream)
            Bass.BASS_StreamFree(Stream)
        End If

        ' create a new instanze of mVisParam
        If mVisParam Is Nothing Then
            mVisParam = New Vis.BASS_VIS_PARAM(Vis.BASSVISPlugin.BASSVISKIND_WINAMP)
        End If

        StreamFile = lstPathList.Items(Playlist.SelectedIndex)
        MediaTitle = Playlist.Items(Playlist.SelectedIndex)

        Stream = Bass.BASS_StreamCreateFile(StreamFile, 0, 0, 0)

        If Stream <> 0 Then
            mySync = New Un4seen.Bass.SYNCPROC(AddressOf SyncEndProc)
            SyncEnd = Bass.BASS_ChannelSetSync(Stream, BASSSync.BASS_SYNC_END, 0, mySync, 0)
            lblTime.Text = GetTime(Bass.BASS_ChannelBytes2Seconds(Stream, Bass.BASS_ChannelGetLength(Stream, BassMode.BASS_POS_BYTES)))

            ' play the filestream
            Bass.BASS_ChannelPlay(Stream, False)
            BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.Play)

        End If

        Select Case mVisParam.Kind
            Case Vis.BASSVISPlugin.BASSVISKIND_WINAMP
                If VisWindowHandle <> 0 Then
                    ' send the last active Playlist index to visplugin
                    BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.SetPlaylistPos, PlaylistPos)

                    ' Send Status Play
                    BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.Play)
                    nReturn = BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.IsPlaying)

                    ' Check Play Status
                    If nReturn = Vis.BASSVISPlayState.Play Then
                        tmrChanInfo.Enabled = True
                    Else
                        tmrChanInfo.Enabled = False
                    End If

                    If (mVisParam.VisHandle <> 0) And (optDevice.Checked = False) Then
                        BASSVIS.BASS_VIS_RenderChannel(mVisParam, Stream)
                    End If

                Else
                    tmrChanInfo.Enabled = True
                End If
            Case Vis.BASSVISPlugin.BASSVISKIND_SONIQUE

                If (mVisParam.VisHandle <> 0) And (optDevice.Checked = False) Then
                    BASSVIS.BASS_VIS_RenderChannel(mVisParam, Stream)
                End If
                tmrChanInfo.Enabled = True

            Case Vis.BASSVISPlugin.BASSVISKIND_WMP
                If mInfos Is Nothing Then
                    mInfos = New Vis.BASS_VIS_INFO(MediaTitle, StreamFile)
                End If

                With mInfos
                    .Channels = 2
                    .BitRate = 44100
                    .SongTitle = MediaTitle
                End With
                BASSVIS.BASS_VIS_SetInfo(mVisParam, mInfos)

                If (mVisParam.VisHandle <> 0) And (optDevice.Checked = False) Then
                    BASSVIS.BASS_VIS_RenderChannel(mVisParam, Stream)
                End If
                tmrChanInfo.Enabled = True

        End Select

    End Sub

    Public Function GetTime(ByVal seconds As Int32) As String

        Dim hour As Single
        Dim min As Single
        Dim sec As Single

        hour = seconds / 60 / 60
        sec = seconds Mod 60
        min = (hour - Int(hour)) * 60

        GetTime = Format(Int(hour), "00") & ":" & Format(Int(min), "00") & ":" & Format(Int(sec), "00")

    End Function

    Private Sub cmdStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStop.Click

        StopPlaying()

    End Sub

    Private Sub StopPlaying()

        ' Stop stream when available

        If Stream <> 0 Then
            Bass.BASS_ChannelStop(Stream)
        End If

        ' SendMessage Status Stop
        BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.Stop)

    End Sub

    Private Sub FilePaused()
        Paused = Not Paused
        If Paused = False Then
            If Stream <> 0 Then
                Bass.BASS_ChannelPlay(Stream, False)

                ' Status Play
                BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.Play)
            End If
        Else
            If Stream <> 0 Then
                Bass.BASS_ChannelPause(Stream)

                ' Status Paused
                BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.Pause)
            End If
        End If

    End Sub

    Private Sub cmdPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPause.Click

        FilePaused()

    End Sub

    Private Sub cmdADD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdADD.Click

        Dim vFiles As Object
        Dim lFile As Int32
        Dim file As String

        On Error GoTo MS

        Playlist.Items.Clear()
        lstPathList.Items.Clear()

        With OpenFileDialog1
            .FileName = ""
            .Title = "Select File(s)..."
            .Multiselect = True
            .Filter = "All files (*.mp3*)|*.mp3*"
            .ShowDialog()
            vFiles = Split(.FileName, Chr(0))

            For Each file In OpenFileDialog1.FileNames
                lstPathList.Items.Add(file)
                Playlist.Items.Add(GetBaseName(Path.GetFileName(file)))
            Next
        End With
        If Playlist.Items.Count <> 0 Then
            Playlist.SelectedIndex = 0
        End If

        cmdPrev.Enabled = True
        cmdPlay.Enabled = True
        cmdStop.Enabled = True
        cmdPause.Enabled = True
        cmdNext.Enabled = True

        PlaylistCount = Playlist.Items.Count
        PlaylistPos = Playlist.SelectedIndex

MS:
    End Sub

    Public Sub MusikEnd()

        If ckRandom.Checked = True Then

            If (PlaylistPos = Playlist.Items.Count - 1) Then
                Playlist.SelectedIndex = 0

                ' play filestream
                PlayFile()
            Else
                PlayNext()
            End If

        Else
            ' stop filestream
            StopPlaying()
            Bass.BASS_ChannelRemoveSync(Stream, SyncEnd)
        End If

    End Sub

    Private Sub cmdStartVis_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStartVis.Click

        Dim Counter As Integer
        Dim IsFree As Boolean

        ' check if we have something selected on the list

        If (lstPlugins.SelectedIndex >= 0) And (lstPlugins.SelectedIndex < lstPlugins.Items.Count) Then
            If mVisParam.VisHandle <> 0 Then
                tmrChanInfo.Enabled = False

                If mVisParam.VisHandle <> 0 Then
                    BASSVIS.BASS_VIS_Free(mVisParam)
                    Do Until (IsFree = True) Or (Counter = 250)
                        IsFree = BASSVIS.BASS_VIS_IsFree(mVisParam)
                        Application.DoEvents()
                        Counter = Counter + 1
                    Loop
                    IsFree = False
                    mVisParam.VisHandle = 0
                End If

                'Clear the image
                picPlgSource.Image = Nothing

            End If

            Select Case mVisParam.Kind
                Case Vis.BASSVISPlugin.BASSVISKIND_WINAMP
                    ' create our new plugin
                    If mExec Is Nothing Then
                        mExec = New Vis.BASS_VIS_EXEC(Vis.BASSVISPlugin.BASSVISKIND_WINAMP)
                    End If

                    If optPicBox.Checked Then
                        With mExec
                            .PluginFile = PluginDir & "\" & lstPlugins.Items(IndexNum)
                            .AMP_ModuleIndex = VisModules.SelectedIndex
                            .AMP_UseOwnW1 = 1
                            .AMP_UseOwnW2 = IIf(ckShowW2.Checked = True, 1, 0)
                        End With

                        BASSVIS.BASS_VIS_ExecutePlugin(mExec, mVisParam)

                    ElseIf optDefault.Checked Then

                        With mExec
                            .PluginFile = PluginDir & "\" & lstPlugins.Items(IndexNum)
                            .AMP_ModuleIndex = VisModules.SelectedIndex
                            .AMP_UseOwnW1 = 0
                            .AMP_UseOwnW2 = 0
                        End With

                        BASSVIS.BASS_VIS_ExecutePlugin(mExec, mVisParam)

                    End If

                    If mVisParam.VisHandle <> 0 Then

                        ' Get HWND from Winamp Dummy Window
                        VisWindowHandle = mVisParam.VisWinHandle

                        ' send the last active Playlist index to visplugin
                        BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.SetPlaylistPos, PlaylistPos)

                        ' SendMessage Playing Status
                        BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.Play)

                        ' Check IsPlaying
                        BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.IsPlaying)

                        If optPicBox.Checked Then

                            hWndGen = mVisParam.VisGenWinHandle

                            If hWndGen <> 0 Then
                                BASSVIS.BASS_VIS_SetVisPort(mVisParam, _
                                                   hWndGen, _
                                                   picPlgSource.Handle, _
                                                   0, _
                                                   0, _
                                                   picPlgSource.Width, _
                                                   picPlgSource.Height)
                            End If

                        End If

                    End If
                    sliFFTSpectrum.Value = CInt(GetSetting(Application.ProductName, "BassVis", "FFTAMPSpectrum", "128"))

                    If optDevice.Checked Then
                        Bass.BASS_RecordInit(0)
                        BASSVIS.BASS_VIS_StartRecord(mVisParam)
                    End If

                    If Stream <> 0 And optfile.Checked = True Then
                        BASSVIS.BASS_VIS_RenderChannel(mVisParam, Stream)
                    End If
                    tmrChanInfo.Enabled = True

                Case Vis.BASSVISPlugin.BASSVISKIND_SONIQUE

                    ' create our new plugin
                    If mExec Is Nothing Then
                        mExec = New Vis.BASS_VIS_EXEC(Vis.BASSVISPlugin.BASSVISKIND_SONIQUE)
                    End If

                    If optPicBox.Checked = True Then
                        With mExec
                            .PluginFile = lstPlgPath.Items(IndexNum) + lstPlugins.Items(IndexNum)
                            .SON_ConfigFile = PluginDir & "\" & "vis.ini"
                            .SON_Flags = Vis.BASSVISFlags.BASS_VIS_DEFAULT
                            .SON_PaintHandle = GetDc(picPlgSource.Handle)
                            .Left = 0
                            .Top = 0
                            .Width = picPlgSource.Width
                            .Height = picPlgSource.Height
                        End With

                        BASSVIS.BASS_VIS_ExecutePlugin(mExec, mVisParam)

                        fftSlowFade.Value = 2
                    End If

                    If mVisParam.VisHandle <> 0 Then
                        If optDevice.Checked = True Then
                            Bass.BASS_RecordInit(0)
                            BASSVIS.BASS_VIS_StartRecord(mVisParam)
                        End If

                        If Stream <> 0 And optfile.Checked = True Then
                            BASSVIS.BASS_VIS_RenderChannel(mVisParam, Stream)
                        End If

                        tmrChanInfo.Enabled = True
                    End If

                Case Vis.BASSVISPlugin.BASSVISKIND_WMP
                    ' create our new plugin
                    If Stream <> 0 And (optfile.Checked = True) Or (optDevice.Checked = True) Then
                        If (optPicBox.Checked) Or (optDefault.Checked = True) Then
                            With mInfos
                                .Channels = 2
                                .BitRate = 44100
                                .SongTitle = MediaTitle
                            End With
                            BASSVIS.BASS_VIS_SetInfo(mVisParam, mInfos)

                            ' create our new plugin
                            If mExec Is Nothing Then
                                mExec = New Vis.BASS_VIS_EXEC(Vis.BASSVISPlugin.BASSVISKIND_SONIQUE)
                            End If

                            With mExec
                                .WMP_PluginIndex = IndexNum
                                .WMP_PresetIndex = VisModules.SelectedIndex
                                .WMP_SrcVisHandle = picPlgSource.Handle
                                .Left = 0
                                .Top = 0
                                .Width = picPlgSource.Width
                                .Height = picPlgSource.Height
                            End With
                            BASSVIS.BASS_VIS_ExecutePlugin(mExec, mVisParam)
                        End If

                        ' new vishandle
                        VisWindowHandle = mVisParam.VisWinHandle

                        If mVisParam.VisHandle <> 0 Then
                            BASSVIS.BASSVIS_SetModulePreset(mVisParam, VisModules.SelectedIndex)
                            BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.Play)
                            sliFFTWMPSpectrum.Value = 128

                            If optDevice.Checked = True Then
                                Bass.BASS_RecordInit(0)
                                BASSVIS.BASS_VIS_StartRecord(mVisParam)
                            End If

                            If Stream <> 0 And optfile.Checked = True Then
                                BASSVIS.BASS_VIS_RenderChannel(mVisParam, Stream)
                            End If

                            tmrChanInfo.Enabled = True
                        End If
                    End If

            End Select

        End If

    End Sub

    Private Sub sliFFTSpectrum_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles sliFFTSpectrum.Scroll

        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_WINAMP Then
            lblFFTSensitivityVal.Text = CLng(sliFFTSpectrum.Value) * 32
        End If


    End Sub

    Private Sub sliFFTSpectrum_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles sliFFTSpectrum.ValueChanged

        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_WINAMP Then
            BASSVIS.BASS_VIS_SetOption(mVisParam, Vis.BASSVISConfig.BASS_SONIQUEVIS_CONFIG_FFTAMP, CLng(sliFFTSpectrum.Value))
            lblFFTSensitivityVal.Text = CLng(sliFFTSpectrum.Value) * 32
        End If
        SaveSetting(Application.ProductName, "BassVis", "FFTAMPSpectrum", CStr(sliFFTSpectrum.Value))

    End Sub


    Private Sub Playlist_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Playlist.DoubleClick

        If Playlist.Items.Count > 0 Then
            PlaylistPos = Playlist.SelectedIndex
            PlayFile()
        End If


    End Sub


    Private Sub GetInput()

        Dim i As Int32
        Dim vLevel As Single

        If (input_ > -1) Then
            input_ = cmbInputs.SelectedIndex
            'enable the selected input

            For i = 0 To cmbInputs.Items.Count - 1
                Bass.BASS_RecordSetInput(i, BASSInput.BASS_INPUT_OFF, -1)
            Next
            Bass.BASS_RecordSetInput(input_, BASSInput.BASS_INPUT_ON, -1)

        End If

        Bass.BASS_RecordGetInput(cmbInputs.SelectedIndex, vLevel)
        slLevel.Value = vLevel * 100

    End Sub

    Private Sub slLevel_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles slLevel.Scroll

        lblLevel.Text = slLevel.Value

    End Sub

    Private Sub slLevel_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles slLevel.ValueChanged

        Call Bass.BASS_RecordSetInput(cmbInputs.SelectedIndex, BASSInput.BASS_INPUT_ON, slLevel.Value / 100)
        lblLevel.Text = slLevel.Value

    End Sub

    Private Sub cmbInputs_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmbInputs.SelectedIndexChanged

        GetInput()

    End Sub


    Private Sub optDevice_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optDevice.CheckedChanged

        If mVisParam.VisHandle <> 0 Then
            Bass.BASS_RecordInit(0)
            BASSVIS.BASS_VIS_StartRecord(mVisParam)
        End If

    End Sub

    Private Sub optfile_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optfile.CheckedChanged

        If Stream <> 0 Then
            BASSVIS.BASS_VIS_RenderChannel(mVisParam, Stream)
        End If

    End Sub


    Public Sub BASSVIS_StateCallback(ByVal NewState As Vis.BASSVISPlayState)

        'CallBack PlayState for Winamp only
        Select Case NewState

            Case Vis.BASSVISPlayState.Stop
                If (Bass.BASS_ChannelIsActive(Stream) = BassActive.BASS_ACTIVE_PLAYING) Or _
                    (Bass.BASS_ChannelIsActive(Stream) = BassActive.BASS_ACTIVE_PAUSED) Then

                    StopPlaying()
                    BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.Stop)
                End If
            Case Vis.BASSVISPlayState.Play
                If Not (Bass.BASS_ChannelIsActive(Stream) = BassActive.BASS_ACTIVE_PLAYING) And Not _
                    (Bass.BASS_ChannelIsActive(Stream) = BassActive.BASS_ACTIVE_PAUSED) Then
                    PlayFile()
                Else
                    Bass.BASS_ChannelPlay(Stream, False)
                    BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.Play)
                    Paused = False
                End If
            Case Vis.BASSVISPlayState.Pause
                Paused = False
                FilePaused()
                BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.Pause)
            Case Vis.BASSVISPlayState.PrevTitle
                PlaylistPos = Playlist.SelectedIndex
                If PlaylistPos > 0 Then
                    PlayPrev()
                End If
            Case Vis.BASSVISPlayState.NextTitle
                If PlaylistPos < (Playlist.Items.Count - 1) Then
                    PlayNext()
                End If
                ' set aktive Playlist entry from Plugin to your PlayList
            Case Vis.BASSVISPlayState.SetPlaylistPos
                Playlist.SelectedIndex = BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.GetSelectedTitlePos)
                PlaylistPos = Playlist.SelectedIndex
                PlayFile()
                ' Plugin send give me a Playlist Title
            Case Vis.BASSVISPlayState.SetPlaylistTitle
                If (Playlist.Items.Count <> 0) And (lstPathList.Items.Count <> 0) Then

                    Call BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.SetPlaylistTitle, -1, _
                                                       Playlist.Items(PlaylistTitlePos))
                End If
                ' Plugin send index from Plugin List
            Case Vis.BASSVISPlayState.GetPlaylistTitlePos
                PlaylistTitlePos = BASSVIS.BASS_VIS_SetPlayState(mVisParam, Vis.BASSVISPlayState.GetPlaylistTitlePos)

        End Select

    End Sub


    Private Sub cbVisType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbVisType.SelectedIndexChanged

        tmrChanInfo.Enabled = False

        'Remove CallBack
        BASSVIS.BASS_VIS_WINAMPRemoveCallback()

        If mVisParam.VisHandle <> 0 Or mVisParam.Kind <> 0 Then
            BASSVIS.BASS_VIS_Quit(mVisParam)
            picPlgSource.Image = Nothing
        End If

        Select Case cbVisType.SelectedIndex
            Case Vis.BASSVISPlugin.BASSVISKIND_WINAMP
                'initialize BassVis use Handle from picFakeAMPWindow that not change Caption
                BASSVIS.BASS_VIS_Init(Vis.BASSVISPlugin.BASSVISKIND_WINAMP, System.Runtime.InteropServices.Marshal.GetHINSTANCE(GetType(Application).Module), Me.Handle)
                PluginDir = Application.StartupPath & "\Plugins"
                fraWinAMP.BringToFront()
                'SetCallBack for PlayState
                mVisCallback = New Vis.BASSVISSTATE(AddressOf BASSVIS_StateCallback)
                BASSVIS.BASS_VIS_WINAMPSetStateCallback(mVisCallback)
            Case Vis.BASSVISPlugin.BASSVISKIND_SONIQUE
                'initialize BassVis use Handle from picFakeAMPWindow that not change Caption
                BASSVIS.BASS_VIS_Init(Vis.BASSVISPlugin.BASSVISKIND_SONIQUE, System.Runtime.InteropServices.Marshal.GetHINSTANCE(GetType(Application).Module), Me.Handle)
                PluginDir = Application.StartupPath & "\SPlugins"
                fraSonique.BringToFront()
            Case Vis.BASSVISPlugin.BASSVISKIND_WMP
                'initialize WMP
                BASSVIS.BASS_VIS_Init(Vis.BASSVISPlugin.BASSVISKIND_WMP, System.Runtime.InteropServices.Marshal.GetHINSTANCE(GetType(Application).Module), Me.Handle)
                PluginDir = vbNullString
                fraWMP.BringToFront()
        End Select

        GetPlugin(cbVisType.SelectedIndex)

    End Sub

    Private Sub fftZoom_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles fftZoom.Scroll

        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_SONIQUE Then
            BASSVIS.BASS_VIS_SetOption(mVisParam, Vis.BASSVISConfig.BASS_SONIQUEVIS_CONFIG_FFT_SKIPCOUNT, CLng(fftZoom.Value))
            lblFFTZoom.Text = fftZoom.Value
        End If

    End Sub

    Private Sub fftZoom_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles fftZoom.ValueChanged

        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_SONIQUE Then
            BASSVIS.BASS_VIS_SetOption(mVisParam, Vis.BASSVISConfig.BASS_SONIQUEVIS_CONFIG_FFT_SKIPCOUNT, CLng(fftZoom.Value))
            lblFFTZoom.Text = fftZoom.Value
        End If

    End Sub

    Private Sub fftWaveZoom_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles fftWaveZoom.Scroll

        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_SONIQUE Then
            BASSVIS.BASS_VIS_SetOption(mVisParam, Vis.BASSVISConfig.BASS_SONIQUEVIS_CONFIG_WAVE_SKIPCOUNT, CLng(fftWaveZoom.Value))
            lblWaveZoom.Text = fftWaveZoom.Value
        End If

    End Sub

    Private Sub fftWaveZoom_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles fftWaveZoom.ValueChanged

        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_SONIQUE Then
            BASSVIS.BASS_VIS_SetOption(mVisParam, Vis.BASSVISConfig.BASS_SONIQUEVIS_CONFIG_WAVE_SKIPCOUNT, CLng(fftWaveZoom.Value))
            lblWaveZoom.Text = fftWaveZoom.Value
        End If

    End Sub

    Private Sub fftSensitivity_Scroll(ByVal sender As Object, ByVal e As System.EventArgs) Handles fftSensitivity.Scroll


        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_SONIQUE Then
            BASSVIS.BASS_VIS_SetOption(mVisParam, Vis.BASSVISConfig.BASS_SONIQUEVIS_CONFIG_FFTAMP, CLng(fftSensitivity.Value))
            lblFFTSoniqueSensitivityVal.Text = CLng(fftSensitivity.Value)
        End If

    End Sub

    Private Sub fftSensitivity_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles fftSensitivity.ValueChanged


        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_SONIQUE Then
            BASSVIS.BASS_VIS_SetOption(mVisParam, Vis.BASSVISConfig.BASS_SONIQUEVIS_CONFIG_FFTAMP, CLng(fftSensitivity.Value))
            lblFFTSoniqueSensitivityVal.Text = CLng(fftSensitivity.Value)
        End If

    End Sub

    Private Sub fftSlowFade_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles fftSlowFade.Scroll

        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_SONIQUE Then
            BASSVIS.BASS_VIS_SetOption(mVisParam, Vis.BASSVISConfig.BASS_SONIQUEVIS_CONFIG_SLOWFADE, CLng(fftSlowFade.Value))
            lblSlowFade.Text = fftSlowFade.Value
        End If

    End Sub

    Private Sub fftSlowFade_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles fftSlowFade.ValueChanged

        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_SONIQUE Then
            BASSVIS.BASS_VIS_SetOption(mVisParam, Vis.BASSVISConfig.BASS_SONIQUEVIS_CONFIG_SLOWFADE, CLng(fftSlowFade.Value))
            lblSlowFade.Text = fftSlowFade.Value
        End If

    End Sub

    Private Sub picPlgSource_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles picPlgSource.DoubleClick

        FullScreen = Not FullScreen
        Select Case mVisParam.Kind

            Case Vis.BASSVISPlugin.BASSVISKIND_SONIQUE, Vis.BASSVISPlugin.BASSVISKIND_WMP
                BASSVIS.BASS_VIS_SetFullscreen(mVisParam, picPlgSource.Handle, Me.Handle, 7560, 240, 328, 272, FullScreen, FScreenWidth, FScreenHeight)

        End Select


    End Sub

    Private Sub cbFullScreenRes_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbFullScreenRes.SelectedIndexChanged

        Select Case cbFullScreenRes.SelectedIndex

            Case 0
                FScreenWidth = 320
                FScreenHeight = 240
            Case 1
                FScreenWidth = 512
                FScreenHeight = 384
            Case 2
                FScreenWidth = 640
                FScreenHeight = 480
            Case 3
                FScreenWidth = 800
                FScreenHeight = 600
            Case 4
                FScreenWidth = 1024
                FScreenHeight = 768
        End Select

    End Sub

    Private Sub picPlgSource_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picPlgSource.MouseDown

        Select Case mVisParam.Kind

            Case Vis.BASSVISPlugin.BASSVISKIND_SONIQUE
                BASSVIS.BASS_VIS_SONIQUEClicked(mVisParam.VisHandle, e.X, e.Y)
        End Select

    End Sub

    Private Sub optPicBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles optPicBox.Click

        cmdStartVis_Click(sender, e)

    End Sub

    Private Sub optDefault_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles optDefault.Click

        cmdStartVis_Click(sender, e)

    End Sub

    Private Sub sliFFTWMPSpectrum_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles sliFFTWMPSpectrum.Scroll

        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_WMP Then
            lblFFTWMPValue.Text = CLng(sliFFTWMPSpectrum.Value) * 32
        End If

    End Sub

    Private Sub sliFFTWMPSpectrum_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles sliFFTWMPSpectrum.ValueChanged

        If mVisParam.Kind = Vis.BASSVISPlugin.BASSVISKIND_WMP Then
            BASSVIS.BASS_VIS_SetOption(mVisParam, Vis.BASSVISConfig.BASS_WMPVIS_CONFIG_FFTAMP, CLng(sliFFTWMPSpectrum.Value))
            lblFFTWMPValue.Text = CLng(sliFFTWMPSpectrum.Value) * 32
        End If

    End Sub

    Private Sub VisModules_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VisModules.SelectedIndexChanged

        Select Case mVisParam.Kind

            Case Vis.BASSVISPlugin.BASSVISKIND_WMP
                If Stream <> 0 Or optDevice.Checked = True Then
                    BASSVIS.BASSVIS_SetModulePreset(mVisParam, VisModules.SelectedIndex)
                End If
        End Select

    End Sub

End Class


