' BassVis 2.4.1.2
' An extension allowing the use of Sonique, Winamp, Windows Media Player and BassBox visual plugins with BASS.
' Copyright  2007 BrewIdeas@Emil Weiss, All Rights Reserved

#IF NOT %DEF(%BASSVIS_INC)
    %BASSVIS_INC = 1

'typedef DWORD HVIS;
'typedef unsigned __int64 QWORD;

' // BASS_SONIQUEVIS_CreateVis flags
%BASS_VIS_NOINIT            = 1

' // Config flags
%BASS_VIS_CONFIG_FFTAMP                = 1
%BASS_SONIQUEVIS_CONFIG_FFT_SKIPCOUNT  = 2   ' // Skip count range is from 0 to 3 (because of limited FFT request size)
%BASS_SONIQUEVIS_CONFIG_WAVE_SKIPCOUNT = 3   ' // Skip count range is from 0 to (...) try it out, whenever Bass crashes or does not return enough sample data
%BASS_SONIQUEVIS_CONFIG_SLOWFADE       = 4   ' // Dim light colors to less than half, then slowly fade them out
%BASS_SONIQUEVIS_CONFIG_RENDERTIMING   = 5   ' // RenderTiming default = 16 ms (min 10)
%BASS_SONIQUEVIS_CONFIG_USESLOWFADE    = 6   ' // use VideoProc or not , 0/off 1/on

' // BASS_VIS_FindPlugin flags
%BASS_VIS_FIND_RECURSIVE        = 4

' //Plugin kind
%BASSVISKIND_NONE    = 0   ' // no kind
%BASSVISKIND_WINAMP  = 1   ' // Winamp
%BASSVISKIND_SONIQUE = 2   ' // Sonique
%BASSVISKIND_WMP     = 3   ' // Windows Media Player
%BASSVISKIND_BASSBOX = 4   ' // BassBox

'typedef int BASSVIS_KIND_T;

TYPE BASSVIS_PARAM
   VisHandle       AS DWORD   ' HVIS // VisHandle
   VisWinHandle    AS DWORD   ' HWND // Vis Window Handle         W2
   VisGenWinHandle AS DWORD   ' HWND // General Vis Window Handle W5
   Kind            AS LONG    ' BASSVIS_KIND_T // Plugin kind
END TYPE

TYPE BASSVIS_EXEC
   Pluginfile         AS ASCIIZ PTR   ' char* // path to Plugin kind
   AMP_UseOwnW1       AS DWORD        ' DWORD // flags for Winamp (ownHDC)
   AMP_UseOwnW2       AS DWORD        ' DWORD // flags for Winamp (ownHDCW2)
   AMP_Moduleindex    AS DWORD        ' DWORD // Modul-index for Winamp
   SON_PaintHandle    AS DWORD        ' HDC   // Painthandle for Sonique
   SON_ConfigFile     AS ASCIIZ PTR   ' char* // path to configfile Sonique
   SON_Flags          AS DWORD        ' DWORD // flags for Sonique
   WMP_PluginIndex    AS LONG         ' int   // Pluginindex fr WMP;
   WMP_PresetIndex    AS LONG         ' int   // Presetindex fr WMP;
   WMP_SrcVisHandle   AS DWORD        ' HWND  // ContainerVisHandle fr WMP;
   BB_ParentHandle    As Long         ' Parent Windowhandle
   BB_Flags           As Long         ' int   // self as flags for Sonique
   BB_ShowFPS         As Long         ' int   // show Frames per Sec
   BB_ShowPrgBar      As Long         ' int   // show progressbar
   Width              AS LONG         ' int   // SrcWindow width
   Height             AS LONG         ' int   // SrcWindow height
   Left               AS LONG         ' int   // SrcWindow left
   Top                AS LONG         ' int   // SrcWindow top
END TYPE

TYPE BASSVIS_INFO
   SongTitle   AS ASCIIZ PTR   ' char * // songtitel
   Songfile    AS ASCIIZ PTR   ' char * // songTitle with path
   pos         AS DWORD        ' DWORD  // stream position
   len         AS DWORD        ' DWORD  // stream length
   PlaylistPos AS DWORD        ' DWORD  // playlist position
   Playlistlen AS DWORD        ' DWORD  // playlist entry
   SampleRate  AS LONG         ' int    // samplerate
   BitRate     AS LONG         ' int    // bitrate
   Duration    AS DWORD        ' DWORD  // duration
   Channels    AS LONG         ' int    // channel default 2 (stereo)
END TYPE

' enum BASSVIS_PLAYSTATE
%psError               = -1
%psStop                = 0
%psPlay                = 1
%psIsPlaying           = 2
%psPause               = 3
%psPrevTitle           = 4
%psNextTitle           = 5
%psSetPlaylistTitle    = 6
%psGetPlaylistTitlePos = 7
%psSetPlaylistPos      = 8
%psGetSelectedTitlePos = 9
%psPlaylistClear       = 10
%psAddPlaylistTitle    = 11

'typedef void (CALLBACK BASSVIS_STATECALLBACK)(BASSVIS_PLAYSTATE state);
'SUB BASSVIS_STATECALLBACK (BYVAL state AS LONG)

' ========================================================================================
' Initializes a Plugin (and BassVis), and sets the default values.
' BOOL BASSVISDEF(BASSVIS_Init)(BASSVIS_KIND_T Kind, HINSTANCE AppHandle, HWND WinHandle);
' ========================================================================================
DECLARE FUNCTION BASSVIS_Init LIB "bass_vis.dll" ALIAS "BASSVIS_Init" ( _
   BYVAL LONG _                               ' __in BASSVIS_KIND_T Kind
 , BYVAL DWORD _                              ' __in HINSTANCE AppHandle
 , BYVAL DWORD _                              ' __in HWND WinHandle
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Starts the visualization of the plugin for the current playing song.
' BOOL BASSVISDEF(BASSVIS_RenderChannel)(BASSVIS_PARAM* Param, DWORD channel);
' ========================================================================================
DECLARE FUNCTION BASSVIS_RenderChannel LIB "bass_vis.dll" ALIAS "BASSVIS_RenderChannel" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYVAL DWORD _                              ' __in DWORD channel
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Starts visualization of the selected device (using recording functions of BASS).
' To select the device use BASS_RECORDINIT function.
' BOOL BASSVISDEF(BASSVIS_StartRecord)(BASSVIS_PARAM* Param, int SampleRate = 44100, int Channels = 2);
' ========================================================================================
DECLARE FUNCTION BASSVIS_StartRecord LIB "bass_vis.dll" ALIAS "BASSVIS_StartRecord" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYVAL LONG _                               ' __in int SampleRate
 , BYVAL LONG _                               ' __in int Channels
 ) AS LONG                                    ' BOOL

' ========================================================================================
' This function calls the integrated configuration dialog of a plugin, if one is available.
' BOOL BASSVISDEF(BASSVIS_Config)(BASSVIS_PARAM* Param, int Entry = 0);
' ========================================================================================
DECLARE FUNCTION BASSVIS_Config LIB "bass_vis.dll" ALIAS "BASSVIS_Config" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYVAL LONG _                               ' __in int Entry
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Gives informations about the song to the plugin.
' BOOL BASSVISDEF(BASSVIS_SetInfo)(BASSVIS_PARAM* Param, BASSVIS_INFO Infos);
' ========================================================================================
DECLARE FUNCTION BASSVIS_SetInfo LIB "bass_vis.dll" ALIAS "BASSVIS_SetInfo" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYREF BASSVIS_INFO _                       ' __in BASSVIS_INFO Infos
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Repositions/Resizes the visualization of the plugin if the container was resized.
' BOOL BASSVISDEF(BASSVIS_Resize)(BASSVIS_PARAM* Param, int Left, int Top, int Width, int Height);
' ========================================================================================
DECLARE FUNCTION BASSVIS_Resize LIB "bass_vis.dll" ALIAS "BASSVIS_Resize" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYVAL LONG _                               ' __in int Left
 , BYVAL LONG _                               ' __in int Top
 , BYVAL LONG _                               ' __in int Width
 , BYVAL LONG _                               ' __in int Height
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Switch the plugin to Fullscreen-mode.
' BOOL BASSVISDEF(BASSVIS_SetFullscreen)(BASSVIS_PARAM* Param, HWND SourceHandle,
' HWND DestHandle, int SourceLeft, int SourceTop, int SourceWidth, int SourceHeight,
' BOOL FullScreenFlag, int FullScreeWidth, int FullScreenHeight);
' ========================================================================================
DECLARE FUNCTION BASSVIS_SetFullscreen LIB "bass_vis.dll" ALIAS "BASSVIS_SetFullscreen" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYVAL DWORD _                              ' __in HWND SourceHandle
 , BYVAL DWORD _                              ' __in HWND DestHandle
 , BYVAL LONG _                               ' __in int SourceLeft
 , BYVAL LONG _                               ' __in int SourceTop
 , BYVAL LONG _                               ' __in int SourceWidth
 , BYVAL LONG _                               ' __in int SourceHeight
 , BYVAL LONG _                               ' __in BOOL FullScreenFlag
 , BYVAL LONG _                               ' __in int FullScreeWidth
 , BYVAL LONG _                               ' __in int FullScreenHeight
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Sets configuration options.
' BOOL BASSVISDEF(BASSVIS_SetOption)(BASSVIS_PARAM* Param, int option, int value);
' ========================================================================================
DECLARE FUNCTION BASSVIS_SetOption LIB "bass_vis.dll" ALIAS "BASSVIS_SetOption" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYVAL LONG _                               ' __in int option
 , BYVAL LONG _                               ' __in int value
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Checks if the thread of the last started plugin was correctly freed after calling BassVis_Free.
' BOOL BASSVISDEF(BASSVIS_IsFree)(BASSVIS_PARAM* Param);
' ========================================================================================
DECLARE FUNCTION BASSVIS_IsFree LIB "bass_vis.dll" ALIAS "BASSVIS_IsFree" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Frees the handle of a plugin and removes it from memory.
' BOOL BASSVISDEF(BASSVIS_Free)(BASSVIS_PARAM* Param);
' ========================================================================================
DECLARE FUNCTION BASSVIS_Free LIB "bass_vis.dll" ALIAS "BASSVIS_Free" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Searches for plugins of a given kind in a given path.
' Returns a comma separated string with the available plugins.
' char* BASSVISDEF(BASSVIS_FindPlugins)(BASSVIS_KIND_T Kind, char *PluginPath,
' DWORD Searchflags, char *Delemiter);
' ========================================================================================
DECLARE FUNCTION BASSVIS_FindPlugins LIB "bass_vis.dll" ALIAS "BASSVIS_FindPlugins" ( _
   BYVAL LONG _                               ' __in BASSVIS_KIND_T Kind
 , BYREF ASCIIZ _                             ' __in char *PluginPath
 , BYVAL DWORD _                              ' __in DWORD Searchflags
 , BYREF ASCIIZ _                             ' __in char *Delemiter
 ) AS DWORD                                   ' char *

' ========================================================================================
' Gets the name of a module of a plugin.
' char* BASSVISDEF(BASSVIS_GetModulePresetName)(BASSVIS_PARAM* Param, int index, char* PluginName = NULL);
' ========================================================================================
DECLARE FUNCTION BASSVIS_GetModulePresetName LIB "bass_vis.dll" ALIAS "BASSVIS_GetModulePresetName" ( _
   BYREF BASSVIS_PARAM _                      ' BASSVIS_PARAM* Param
 , BYVAL LONG _                               ' int index
 , BYREF ASCIIZ _                             ' char* PluginName
 ) AS DWORD                                   ' char *

' ========================================================================================
' Gets the available module names of a plugin.
' char* BASSVISDEF(BASSVIS_GetModulePresetNameList)(BASSVIS_PARAM* Param, char* PluginName = NULL);
' ========================================================================================
DECLARE FUNCTION BASSVIS_GetModulePresetNameList LIB "bass_vis.dll" ALIAS "BASSVIS_GetModulePresetNameList" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYREF ASCIIZ _                             ' __in char* PluginName
 ) AS DWORD                                   ' char *

' ========================================================================================
' Gets the name of a plugin.
' char* BASSVISDEF(BASSVIS_GetPluginName)(BASSVIS_PARAM* Param);
' ========================================================================================
DECLARE FUNCTION BASSVIS_GetPluginName LIB "bass_vis.dll" ALIAS "BASSVIS_GetPluginName" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 ) AS DWORD                                   ' char *

' ========================================================================================
' Gets the version number of the BassVis.dll
' char* BASSVISDEF(BASSVIS_GetVersion)();
' ========================================================================================
DECLARE FUNCTION BASSVIS_GetVersion LIB "bass_vis.dll" ALIAS "BASSVIS_GetVersion" ( _
 ) AS DWORD                                   ' char *

' ========================================================================================
' Gets the handle of an initialized plugin.
' DWORD BASSVISDEF(BASSVIS_GetPluginHandle)(BASSVIS_KIND_T Kind, char *Pluginfile);
' ========================================================================================
DECLARE FUNCTION BASSVIS_GetPluginHandle LIB "bass_vis.dll" ALIAS "BASSVIS_GetPluginHandle" ( _
   BYVAL LONG _                               ' __in BASSVIS_KIND_T Kind
 , BYREF ASCIIZ _                             ' __in char *Pluginfile
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Starts a plugin.
' void _stdcall BASSVISDEF(BASSVIS_ExecutePlugin)(BASSVIS_EXEC* Param, BASSVIS_PARAM* Base);
' ========================================================================================
DECLARE SUB BASSVIS_ExecutePlugin LIB "bass_vis.dll" ALIAS "BASSVIS_ExecutePlugin" ( _
   BYREF BASSVIS_EXEC _                       ' __in BASSVIS_EXEC* Param
 , BYREF BASSVIS_PARAM _                      ' __in_out BASSVIS_PARAM* Base
 )                                            ' void

' ========================================================================================
' Ends the last active thread and frees the plugin which was created by the
' BASSVIS_ExecutePlugin call.
' void BASSVISDEF(BASSVIS_Quit)(BASSVIS_PARAM* Param);
' ========================================================================================
DECLARE SUB BASSVIS_Quit LIB "bass_vis.dll" ALIAS "BASSVIS_Quit" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Base
 )                                            ' void

' ========================================================================================
' Sets the container of the visualization, an the position and size of it.
' void BASSVISDEF(BASSVIS_SetVisPort)(BASSVIS_PARAM* Param, HWND WindowHandle, HWND ContainerHandle, 
' int Left, Int Top, int Width, int Height);
' ========================================================================================
DECLARE SUB BASSVIS_SetVisPort LIB "bass_vis.dll" ALIAS "BASSVIS_SetVisPort" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
   BYVAL DWORD _                              ' __in HWND WindowHandle
 , BYVAL DWORD _                              ' __in HWND ContainerHandle
 , BYVAL LONG _                               ' __in int Left
 , BYVAL LONG _                               ' __in int Top
 , BYVAL LONG _                               ' __in int Width
 , BYVAL LONG _                               ' __in int Height
 )                                            ' void

' ========================================================================================
' Gets the number of modules in a plugin.
' int BASSVISDEF(BASSVIS_GetModulePresetCount)(BASSVIS_PARAM* Param, char* PluginName);
' ========================================================================================
DECLARE FUNCTION BASSVIS_GetModulePresetCount LIB "bass_vis.dll" ALIAS "BASSVIS_GetModulePresetCount" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYREF ASCIIZ _                             ' __in char* PluginName
 ) AS LONG                                    ' int

' ========================================================================================
' Gets the default value of a configuration option for the current plugin.
' int BASSVISDEF(BASSVIS_GetOption)(BASSVIS_PARAM* Param, int option);
' ========================================================================================
DECLARE FUNCTION BASSVIS_GetOption LIB "bass_vis.dll" ALIAS "BASSVIS_GetOption" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYVAL LONG _                               ' __in int option
 ) AS LONG                                    ' int

' ========================================================================================
' Sets the current play state.
' int BASSVISDEF(BASSVIS_SetPlayState)(BASSVIS_PARAM* Param, BASSVIS_PLAYSTATE State,
' int value = -1, char *Title = "");
' ========================================================================================
DECLARE FUNCTION BASSVIS_SetPlayState LIB "bass_vis.dll" ALIAS "BASSVIS_SetPlayState" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYVAL LONG _                               ' __in BASSVIS_PLAYSTATE State
 , BYVAL LONG _                               ' __in int value
 , BYREF ASCIIZ _                             ' __in char *Title
 ) AS LONG                                    ' int

' //Spezial for Winamp
' ========================================================================================
' Sets a callback function for handling playstate changes on plugins.
' void BASSVISDEF(BASSVIS_WINAMP_SetStateCallback)(BASSVIS_STATECALLBACK callback);
' ========================================================================================
DECLARE SUB BASSVIS_WINAMP_SetStateCallback LIB "bass_vis.dll" ALIAS "BASSVIS_WINAMP_SetStateCallback" ( _
   BYVAL DWORD _                              ' __in BASSVIS_STATECALLBACK callback
 )                                            ' void

' ========================================================================================
' Removes the callback function that was set with a SetCallback call.
' void BASSVISDEF(BASSVIS_WINAMP_RemoveCallback)();
' ========================================================================================
DECLARE SUB BASSVIS_WINAMP_RemoveCallback LIB "bass_vis.dll" ALIAS "BASSVIS_WINAMP_RemoveCallback" ( _
 )                                            ' void

' //Spezial for Sonique
' ========================================================================================
' Shows the configuration for Sonique and Ultraplayer plugins within the visualization.
' BOOL BASSVISDEF(BASSVIS_SONIQUEVIS_Clicked)(HVIS handle, DWORD x, DWORD y);
' ========================================================================================
DECLARE FUNCTION BASSVIS_SONIQUEVIS_Clicked LIB "bass_vis.dll" ALIAS "BASSVIS_SONIQUEVIS_Clicked" ( _
   BYVAL DWORD _                              ' __in HVIS handle
 , BYVAL DWORD _                              ' __in DWORD x
 , BYVAL DWORD _                              ' __in DWORD y
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Renders on device context from selected sound device.
' BOOL BASSVISDEF(BASSVIS_SONIQUEVIS_RenderToDC)(BASSVIS_KIND_T Kind, HVIS visHandle,
' DWORD channel, HDC hDC);
' ========================================================================================
DECLARE FUNCTION BASSVIS_SONIQUEVIS_RenderToDC LIB "bass_vis.dll" ALIAS "BASSVIS_SONIQUEVIS_RenderToDC" ( _
   BYVAL LONG _                               ' __in BASSVIS_KIND_T Kind
 , BYVAL DWORD _                              ' __in HVIS visHandle
 , BYVAL DWORD _                              ' __in DWORD channel
 , BYVAL DWORD _                              ' __in HDC hDC
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Renders the visualization plugin pointed to by the handle parameter onto the specified canvas.
' The canvas is a device context handle in which to draw the visualization.
' BOOL BASSVISDEF(BASSVIS_SONIQUEVIS_RenderToDC2)(BASSVIS_KIND_T Kind, HVIS visHandle,
' void *data, void *fft, HDC canvas, DWORD flags, DWORD pos);
' ========================================================================================
DECLARE FUNCTION BASSVIS_SONIQUEVIS_RenderToDC2 LIB "bass_vis.dll" ALIAS "BASSVIS_SONIQUEVIS_RenderToDC2" ( _
   BYVAL LONG _                               ' __in BASSVIS_KIND_T Kind
 , BYVAL DWORD _                              ' __in HVIS visHandle
 , BYREF ANY _                                ' __in void *data
 , BYREF ANY _                                ' __in void *fft
 , BYVAL DWORD _                              ' __in HDC canvas
 , BYVAL DWORD _                              ' __in DWORD pos
 ) AS LONG                                    ' BOOL

' //Spezial for WMP
' ========================================================================================
' Activates selected preset.
' BOOL BASSVISDEF(BASSVIS_SetModulePreset)(BASSVIS_PARAM* Param, int index);
' ========================================================================================
DECLARE FUNCTION BASSVIS_SetModulePreset LIB "bass_vis.dll" ALIAS "BASSVIS_SetModulePreset" ( _
   BYREF BASSVIS_PARAM _                      ' __in BASSVIS_PARAM* Param
 , BYVAL LONG _                               ' __in int index
 ) AS LONG                                    ' BOOL
 
#ENDIF   ' %BASSVIS_INC
