Attribute VB_Name = "mBassVis"
'mBassVis.BAS
'--------------------------- VB 6.0 Form Module -----------------------------
' BassVis API Module ADD-ON for Bass Audio Library
' Copyright  2007 BrewIdeas@Emil Weiss, All Rights Reserved
'
' Author(s) of this module: Emil Weiss
'
' Code was written in and formatted for 10pt Courier New
'----------------------------------------------------------------------------

Option Explicit
  
  ' BASS_SONIQUEVIS_CreateVis flags
  Public Const BASS_VIS_NOINIT                       As Integer = 1

  ' BASS_VIS_CONFIGFLAGS
  Public Enum BASSVIS_CONFIGFLAGS
    BASS_VIS_CONFIG_FFTAMP                 = 1  ' FFTAMP for Sonique, Winamp, WMP
    BASS_SONIQUEVIS_CONFIG_FFT_SKIPCOUNT   = 2  ' Skip count range is from 0 to 3 (because of limited FFT request size)
    BASS_SONIQUEVIS_CONFIG_WAVE_SKIPCOUNT  = 3  ' Skip count range is from 0 to (...) try it out, whenever Bass crashes or does not return enough sample data
    BASS_SONIQUEVIS_CONFIG_SLOWFADE        = 4  ' Dim light colors to less than half, then slowly fade them out
    BASS_SONIQUEVIS_CONFIG_RENDERTIMING    = 5  ' RenderTiming default = 16 ms (min 10)
    BASS_SONIQUEVIS_CONFIG_USESLOWFADE     = 6  ' use VideoProc or not , 0/off 1/on
  End Enum
  
  ' BASS_VIS_FindPlugin flags
  Public Const BASS_VIS_FIND_RECURSIVE               As Integer = 4

  ' Plugin Kind
  Public Const BASSVISKIND_NONE = 0
  Public Const BASSVISKIND_WINAMP = 1
  Public Const BASSVISKIND_SONIQUE = 2
  Public Const BASSVISKIND_WMP = 3
  Public Const BASSVISKIND_BASSBOX = 4
  
  ' Plugin Parameter
  Public Type BASSVIS_PARAM
     Vishandle       As Long      ' VisHandle
     VisWinhandle    As Long      ' VisWinHandle
     VisGenWinhandle As Long      ' General Vis Window Handle
     Kind            As Long      ' Plugin Kind (BASSVISKIND_NONE, _
                                                 BASSVISKIND_WINAMP, _
                                                 BASSVISKIND_SONIQUE, _
                                                 BASSVISKIND_WMP, _
                                                 BASSVISKIND_BASSBOX, _
                                                 )
  End Type
  
  ' Definition der Typen fr die variablen Parameter bei Create bzw. Execute
  Public Type BASSVIS_EXEC
    Pluginfile            As String  ' Dateiname des Plugins fr Sonique und Winamp
    AMP_UseOwnW1          As Long    ' Flag fr Winamp False =(Render Winamp5 im eigenen Window) 0=aus,1=an
    AMP_UseOwnW2          As Long    ' Flag fr Winamp False =(Render Winamp2 im eigenen Window) 0=aus,1=an
    AMP_Moduleindex       As Long    ' Modul-index fr Winamp
    SON_PaintHandle       As Long    ' Painthandle fr Sonique
    SON_ConfigFile        As String  ' Dateiname der Konfiguration fr Sonique
    SON_Flags             As Long    ' Flags fr Sonique
    WMP_PluginIndex       As Long    ' Pluginindex fr WMP;
    WMP_PresetIndex       As Long    ' Presetindex fr WMP
    WMP_SrcVisHandle      As Long    ' ContainerVisHandle fr WMP
    BB_ParentHandle       As Long    ' Parent Windowhandle
    BB_Flags              As Long    ' Flags fr BassBox selbe wie Sonique
    BB_ShowFPS            As Long    ' Frames pro Sekunde anzeigen
    BB_ShowPrgBar         As Long    ' Progressbar anzeigen
    Width                 As Long    ' Fensterbreite
    Height                As Long    ' Fensterhhe
    Left                  As Long    ' Top
    Top                   As Long    ' Left
  End Type

  Public Type BASSVIS_INFO
    SongTitle    As String     ' SongTitel ohne Pfad
    Songfile     As String     ' SongFile incl. Pfad (StreamFile)
    pos          As Long       ' StreamPos = 1000*StreamPos
    len          As Long       ' Stream lnge
    PlaylistPos  As Long       ' PlaylistPos minimal > 0
    Playlistlen  As Long       ' Playlist lnge
    SampleRate   As Long       ' Samplerate default = 44100
    BitRate      As Long       '
    Duration     As Long       '
    Channels     As Long       ' 2
  End Type

  Public Enum BASSVIS_PLAYSTATE
      psError = -1
      psStop = 0
      psPlay = 1
      psIsPlaying = 2
      psPause = 3
      psPrevTitle = 4
      psNextTitle = 5
      psSetPlaylistTitle = 6
      psGetPlaylistTitlePos = 7
      psSetPlaylistPos = 8
      psGetSelectedTitlePos = 9
      psPlaylistClear = 10
      psAddPlaylistTitle = 11
  End Enum


'Core functions for initalizing BASSVIS and Find Plugins of any kind
Public Declare Function BASSVIS_Init Lib "bass_vis.dll" ( _
    ByVal Kind As Long, _
    ByVal AppHandle As Long, _
    ByVal WinHandle As Long _
) As Boolean


'Core functions for initalizing BASSVIS and Find Plugins of any kind
'delemiter As Byte = 44 .. ASC(",")
'you can send other delemiter for Spliting
Public Declare Function BASSVIS_FindPlugins Lib "bass_vis.dll" ( _
    ByVal Kind As Long, _
    ByVal PluginPath As Any, _
    ByVal Searchflags As Long, _
    Optional ByVal delemiter As Byte = 44 _
) As Long


Public Declare Function BASSVIS_Free Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM _
) As Boolean


Public Declare Function BASSVIS_GetVersion Lib "bass_vis.dll" () As String
 

Public Declare Sub BASSVIS_ExecutePlugin Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_EXEC, _
    ByRef Base As BASSVIS_PARAM _
)


Public Declare Function BASSVIS_RenderChannel Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal channel As Long _
) As Boolean


Public Declare Function BASSVIS_StartRecord Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    Optional ByVal SampleRate As Long = 44100, _
    Optional ByVal Channels As Long = 2 _
) As Boolean


Public Declare Function BASSVIS_Config Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    Optional ByVal Entry As Long = 0 _
) As Boolean


Public Declare Function BASSVIS_SetInfo Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByRef infos As BASSVIS_INFO _
) As Boolean


Public Declare Function BASSVIS_Resize Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal Left As Long, _
    ByVal Top As Long, _
    ByVal Width As Long, _
    ByVal Height As Long _
) As Boolean


Public Declare Function BASSVIS_SetFullscreen Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal SourceHandle As Long, _
    ByVal DestHandle As Long, _
    ByVal SourceLeft As Long, _
    ByVal SourceTop As Long, _
    ByVal SourceWidth As Long, _
    ByVal SourceHeight As Long, _
    ByVal FullScreenFlag As Boolean, _
    ByVal FullScreeWidth As Long, _
    ByVal FullScreenHeight As Long _
) As Boolean


Public Declare Function BASSVIS_GetModulePresetCount Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal PluginName As Any _
) As Long


Public Declare Function BASSVIS_GetModulePresetName Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal index As Long, _
    ByVal PluginName As Any _
) As Long


Public Declare Function BASSVIS_GetModulePresetNameList Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal PluginName As Any _
) As Long


Public Declare Function BASSVIS_GetOption Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal options As Long _
) As Long


Public Declare Function BASSVIS_SetOption Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal options As Long, _
    ByVal value As Long _
) As Boolean


Public Declare Function BASSVIS_SetPlayState Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal State As BASSVIS_PLAYSTATE, _
    Optional ByVal value As Long = -1, _
    Optional ByVal Title As Any = "" _
) As Long


Public Declare Function BASSVIS_GetPluginHandle Lib "bass_vis.dll" ( _
    ByVal Kind As Long, _
    ByVal Pluginfile As Any _
) As Long


Public Declare Function BASSVIS_GetPluginName Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM _
) As Long


Public Declare Function BASSVIS_IsFree Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM _
) As Boolean


Public Declare Sub BASSVIS_Quit Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM _
)


Public Declare Sub BASSVIS_SetVisPort Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal WindowHandle As Long, _
    ByVal ContainerHandle As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal Width As Long, _
    ByVal Height As Long _
)


' Special for Winamp
Public Declare Sub BASSVIS_WINAMP_SetStateCallback Lib "bass_vis.dll" ( _
    ByVal callback As BASSVIS_PLAYSTATE _
)

Public Declare Sub BASSVIS_WINAMP_RemoveCallback Lib "bass_vis.dll" ()


' Special for Sonique
Public Declare Function BASSVIS_SONIQUEVIS_Clicked Lib "bass_vis.dll" ( _
    ByVal handle As Long, _
    ByVal x As Long, _
    ByVal y As Long _
) As Boolean


Public Declare Function BASSVIS_SONIQUEVIS_RenderToDC Lib "bass_vis.dll" ( _
    ByVal Kind As Long, _
    ByVal handle As Long, _
    ByVal channel As Long, _
    ByVal canvas As Long _
) As Long


Public Declare Function BASSVIS_SONIQUEVIS_RenderToDC2 Lib "bass_vis.dll" ( _
    ByVal Kind As Long, _
    ByVal handle As Long, _
    ByVal data As Long, _
    ByVal fft As Long, _
    ByVal canvas As Long, _
    ByVal flags As Long, _
    ByVal pos As Long _
) As Long


' Special for WMP
Public Declare Function BASSVIS_SetModulePreset Lib "bass_vis.dll" ( _
    ByRef param As BASSVIS_PARAM, _
    ByVal index As Long _
) As Boolean

' ************** End BASSVIS Interface **************
'*****************************************************


' Windows API Declaration
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" ( _
    ByVal lpString As Long _
) As Long

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    ByRef Destination As Any, _
    ByRef Source As Any, _
    ByVal Length As Long _
)


Public Function VBStrFromAnsiPtr(ByVal lpStr As Long) As String

Dim bStr() As Byte
Dim cChars As Long

    On Error Resume Next
    ' Get the number of characters in the buffer
    cChars = lstrlen(lpStr)
    ' Resize the byte array
    ReDim bStr(0 To cChars - 1) As Byte
    ' Grab the ANSI buffer
    Call CopyMemory(bStr(0), ByVal lpStr, cChars)
    ' Now convert to a VB Unicode string
    VBStrFromAnsiPtr = StrConv(bStr, vbUnicode)

End Function
